Scriptname wizBushMarkerScript extends ObjectReference  

;This is only used to disable the bush and regrow it later

FormList Property wizBushList Auto
GlobalVariable Property wizOptionDTResetTime Auto
GlobalVariable Property wizOptionBushesRegrow Auto

Float ResetTime
Float originalScale
objectReference ClosestBush 
bool ParentIssues

event onInit()

	if ClosestBush == None ;First Once
		ClosestBush = Game.FindClosestReferenceOfAnyTypeInListFromRef(wizBushList, self, 15)
	
		if ClosestBush
			originalScale= ClosestBush.getScale()
			ClosestBush.disable()
						
			if !ClosestBush.isDisabled()
				;This catches parent problems and add it to an ignore list to prevent
				debug.trace ("********** wizDYNAMIC THINGS - The Enable State Parent error above has been accounted for and will not occur again for this object **********")
				ParentIssues = TRUE
				ClosestBush.setscale(0.05)
			endIf
		else
			;No bush?
			self.disable()
			self.delete()
			return
		endIf

		ResetTime = Utility.GetCurrentGameTime()
	endIf

endEvent

Event OnCellDetach()

	;Restore bush
	if ParentIssues != TRUE
		ClosestBush.enable()
	else
		ClosestBush.setscale(originalScale)
	endIf

	ResetTime = Utility.GetCurrentGameTime() 

;	debug.messagebox("Current:" + Utility.GetCurrentGameTime() + " Reset:" + ResetTime)

endEvent


Event OnCellAttach()
	;Are we past the reset time?
	
;	debug.messagebox(Utility.GetCurrentGameTime() + ">" + ResetTime + " " + closestBush + " " + ParentIssues)

	if utility.getCurrentGameTime() >= (ResetTime+ (wizOptionDTResetTime.getvalue() as float)) && wizOptionBushesRegrow.GetValueInt() == 1
		;Leave visisble and delete this marker
		self.disable()
		self.delete()
	else
		;Still not reset
		if closestBush
			if ParentIssues != TRUE
				ClosestBush.disable()
			else
				ClosestBush.setScale(0.05)
			endIf
		else
			;No bush?
			self.disable()
			self.delete()
		endIf

	endIf
endEvent
