Scriptname wizCrateMarkerScript extends ObjectReference  

wizDTCompatibility Property Compatibility Auto

Container Property wizCrateSmall01Static Auto
Container Property wizCrateSmall01EECoStatic Auto
Container Property wizCrateSmall01WeatheredStatic Auto
Container Property wizCrateSmall02Static Auto
Container Property wizCrateSmall02WeatheredStatic Auto
Container Property wizCrateSmall03Static Auto
Container Property wizCrateSmall03EECoStatic Auto
Container Property wizCrateSmall03WeatheredStatic Auto
Container Property wizCrateSmall04Static Auto
Container Property wizCrateSmall04WeatheredStatic Auto
Container Property wizCrateSmallLong01Static Auto
Container Property wizCrateSmallLong01EECoStatic Auto
Container Property wizCrateSmallLong01WeatheredStatic Auto
Container Property wizCrateSmallLong02Static Auto
Container Property wizCrateSmallLong02WeatheredStatic Auto
Container Property wizCrateSmallLong03Static Auto
Container Property wizCrateSmallLong03WeatheredStatic Auto
Container Property wizCrateSmallLong04Static Auto
Container Property wizCrateSmallLong04WeatheredStatic Auto
Container Property wizCrateSmallLong04EECoStatic Auto

FormList Property wizCrateList Auto
FormList Property wizParentIssues Auto
FormList Property wizCrateSmallList Auto
FormList Property wizCrateLongList Auto
FormList Property wizCrateSmall01List Auto
FormList Property wizCrateSmall01EECoList Auto
FormList Property wizCrateSmall01WeatheredList Auto
FormList Property wizCrateSmall02List Auto
FormList Property wizCrateSmall02WeatheredList Auto
FormList Property wizCrateSmall03List Auto
FormList Property wizCrateSmall03EECoList Auto
FormList Property wizCrateSmall03WeatheredList Auto
FormList Property wizCrateSmall04List Auto
FormList Property wizCrateSmall04WeatheredList Auto
FormList Property wizCrateSmallLong01List Auto
FormList Property wizCrateSmallLong01EECoList Auto
FormList Property wizCrateSmallLong01WeatheredList Auto
FormList Property wizCrateSmallLong02List Auto
FormList Property wizCrateSmallLong02WeatheredList Auto
FormList Property wizCrateSmallLong03List Auto
FormList Property wizCrateSmallLong03WeatheredList Auto
FormList Property wizCrateSmallLong04List Auto
FormList Property wizCrateSmallLong04EECoList Auto
FormList Property wizCrateSmallLong04WeatheredList Auto

;Things to look for
FormList Property wizAlchemyTables Auto
FormList Property wizBreweryCasks Auto
FormList Property wizCookingPotList Auto
FormList Property wizForgeList Auto

;Things to add
LeveledItem Property LItemIngredientsCommon Auto
LeveledItem Property LItemIngredientsUncommon Auto
LeveledItem Property LItemIngredientsRare Auto
LeveledItem Property wizMeadLoot Auto
LeveledItem Property LItemInnRuralDrinkSpecificMeads Auto
LeveledItem Property LItemFoodRawMeat Auto
LeveledItem Property LItemFoodFishList Auto
LeveledItem Property LItemFoodSalt Auto
LeveledItem Property LItemFoodInnCommon Auto
LeveledItem Property LItemBlacksmithMineralsProcessed75 Auto
LeveledItem Property LItemBlacksmithMineralsRaw75 Auto
LeveledItem Property LItemFurnitureMiscItems75 Auto
LeveledItem Property LItemMiscVendorClothing75 Auto

GlobalVariable Property wizDynamicThingsEnabled Auto 
GlobalVariable Property wizOptionCratesEnabled Auto 
GlobalVariable Property wizOptionDTResetTime Auto 

Actor Property ArngeirREF Auto

ObjectReference ClosestCrate
ObjectReference CrateContainer

Bool ParentIssues
Float Respawn

Event OnInit()
	;debug.messagebox(WoodPileContainer)
	if CrateContainer== None ;Only fire once
		placeCrate()
		Respawn = utility.getCurrentGameTime()
	endIf

endEvent


Event OnCellDetach()
	;Re-enable static wood pile - this is mainly for unistallation puposes
	If ParentIssues != TRUE
		ClosestCrate.enable()
	EndIf

	if CrateContainer
		;Disable wood pile container
		CrateContainer.disable()
	else
		;No crate???
		self.disable()
		self.delete()
	endIf

	Respawn = utility.getCurrentGameTime()

endEvent

Event OnCellAttach()
	if wizOptionCratesEnabled.getvalueint() == 1 && wizDynamicThingsEnabled.getvalueint() == 1
		;Find the curent closest barrel  - may be dufferent if Placeable Statics has been removed!
		ClosestCrate= Game.FindClosestReferenceOfAnyTypeInListFromRef(wizCrateList, self, 15)
		if ClosestCrate== None || ClosestCrate.isDeleted() || ClosestCrate.isDisabled()
			;Barrel moved by a mod that moved a vanilla object
			CrateContainer.disable()
			CrateContainer.delete()
			self.disable()
			self.Delete()
		else
			;Might this container be respawning?
			if utility.getCurrentGameTime() >= (Respawn + (wizOptionDTResetTime.getvalue() as float))
				;We are going to loop for 3 seconds to see if CrateContainer gets deleted!
				int iLoop = 6
				While iLoop
					;Is the container deleted?
					if CrateContainer.isDeleted()
						PlaceCrate()
						iLoop = 0
					else
						Utility.wait(0.5)
						iLoop = (iLoop - 1)
					endIf
				endWhile
				
			endIf


			If ParentIssues != TRUE && !wizParentIssues.HasForm(ClosestCrate)
				ClosestCrate.disable()
	
				if !ClosestCrate.IsDisabled()
					;This catches parent problems and add it to an ignore list to prevent
					debug.trace ("********** wizDYNAMIC THINGS - The Enable State Parent error above has been accounted for and will not occur again for this object **********")
					ParentIssues = TRUE
					;Add to parent issues for logging!
					if !(wizParentIssues.HasForm(ClosestCrate)) 
						wizParentIssues.AddForm(ClosestCrate)
					endIf
;					debug.messagebox(ClosestCrate)
				endIf

			EndIf

			if CrateContainer
				CrateContainer.enable()
				if  self.getcurrentlocation() && self.getcurrentlocation().haskeyword(Keyword.getkeyword("LocTypeHabitation"))
					CrateContainer.SetActorOwner(ArngeirREF.GetActorBase())
				endIf
			else
				;Don't know what happend to the container, but delete this marker script
				self.disable()
				self.Delete()
			endIf

		endIf
	EndIf
EndEvent

Function PlaceCrate()

		;Which crate are we replacing?
		ClosestCrate= Game.FindClosestReferenceOfAnyTypeInListFromRef(wizCrateList, self, 15)
		
		if !ClosestCrate
			;How do we exist then?
			self.disable()
			self.delete()
			return
		endIf

		;What type of crate are we replacing?
		if wizCrateSmall01List.HasForm(ClosestCrate.getBaseObject())
			CrateContainer= self.placeatme(wizCrateSmall01Static)
		elseIf wizCrateSmall01EECoList.HasForm(ClosestCrate.getBaseObject())
			CrateContainer= self.placeatme(wizCrateSmall01EECoStatic)
		elseIf wizCrateSmall01WeatheredList.HasForm(ClosestCrate.getBaseObject())
			CrateContainer= self.placeatme(wizCrateSmall01WeatheredStatic)
		elseIf wizCrateSmall02List.HasForm(ClosestCrate.getBaseObject())
			CrateContainer= self.placeatme(wizCrateSmall02Static)
		elseIf wizCrateSmall02WeatheredList.HasForm(ClosestCrate.getBaseObject())
			CrateContainer= self.placeatme(wizCrateSmall02WeatheredStatic)
		elseIf wizCrateSmall03List.HasForm(ClosestCrate.getBaseObject())
			CrateContainer= self.placeatme(wizCrateSmall03Static)
		elseIf wizCrateSmall03EECoList.HasForm(ClosestCrate.getBaseObject())
			CrateContainer= self.placeatme(wizCrateSmall03EECoStatic)
		elseIf wizCrateSmall03WeatheredList.HasForm(ClosestCrate.getBaseObject())
			CrateContainer= self.placeatme(wizCrateSmall03WeatheredStatic)
		elseIf wizCrateSmall04List.HasForm(ClosestCrate.getBaseObject())
			CrateContainer= self.placeatme(wizCrateSmall04Static)
		elseIf wizCrateSmall04WeatheredList.HasForm(ClosestCrate.getBaseObject())
			CrateContainer= self.placeatme(wizCrateSmall04WeatheredStatic)
		elseIf wizCrateSmallLong01List.HasForm(ClosestCrate.getBaseObject())
			CrateContainer= self.placeatme(wizCrateSmallLong01Static)
		elseIf wizCrateSmallLong01EECoList.HasForm(ClosestCrate.getBaseObject())
			CrateContainer= self.placeatme(wizCrateSmallLong01EECoStatic)
		elseIf wizCrateSmallLong01WeatheredList.HasForm(ClosestCrate.getBaseObject())
			CrateContainer= self.placeatme(wizCrateSmallLong01WeatheredStatic)
		elseIf wizCrateSmallLong02List.HasForm(ClosestCrate.getBaseObject())
			CrateContainer= self.placeatme(wizCrateSmallLong02Static)
		elseIf wizCrateSmallLong02WeatheredList.HasForm(ClosestCrate.getBaseObject())
			CrateContainer= self.placeatme(wizCrateSmallLong02WeatheredStatic)
		elseIf wizCrateSmallLong03List.HasForm(ClosestCrate.getBaseObject())
			CrateContainer= self.placeatme(wizCrateSmallLong03Static)
		elseIf wizCrateSmallLong03WeatheredList.HasForm(ClosestCrate.getBaseObject())
			CrateContainer= self.placeatme(wizCrateSmallLong03WeatheredStatic)
		elseIf wizCrateSmallLong04List.HasForm(ClosestCrate.getBaseObject())
			CrateContainer= self.placeatme(wizCrateSmallLong04Static)
		elseIf wizCrateSmallLong04EECoList.HasForm(ClosestCrate.getBaseObject())
			CrateContainer= self.placeatme(wizCrateSmallLong04EECoStatic)
		elseIf wizCrateSmallLong04WeatheredList.HasForm(ClosestCrate.getBaseObject())
			CrateContainer= self.placeatme(wizCrateSmallLong04WeatheredStatic)
		endIf

		;Set the angles!
		CrateContainer.SetAngle(self.GetAngleX(), self.GetAngleY(), self.GetAngleZ())
		;Set the Scale!
		CrateContainer.SetScale(ClosestCrate.getscale())

		;What size crate?
		int Size = 1
		if wizCrateSmallList.HasForm(ClosestCrate.getBaseObject())
			Size =1
		elseIf wizCrateLongList.HasForm(ClosestCrate.getBaseObject())
			Size = 2
		endIf

		if Game.FindClosestReferenceOfAnyTypeInListFromRef(wizBreweryCasks, self, 1000) != None
			;Brewery Casks
			int Mead = Utility.RandomInt(1,100)
			if Mead <= 25
				CrateContainer.AddItem(LItemInnRuralDrinkSpecificMeads,1 *Size,true)
			Else
				CrateContainer.AddItem(wizMeadLoot,5 *Size,true)
			EndIf
		elseIf Game.FindClosestReferenceOfAnyTypeInListFromRef(wizAlchemyTables, self, 1000) != None
			int ingredients = Utility.RandomInt(1,100)
			;Alchemy Tables
			if Ingredients <= 10 ;Rare 
				CrateContainer.AddItem(LItemIngredientsRare,5 *Size,true)
			elseIf Ingredients <=35 ;Uncommon
				CrateContainer.AddItem(LItemIngredientsUncommon,5 *Size,true)
			else ;Common
				CrateContainer.AddItem(LItemIngredientsCommon,5 *Size,true)
			endIf
		elseIf Game.FindClosestReferenceOfAnyTypeInListFromRef(wizCookingPotList, self, 1000) != None
			;Forges and Anvils
			if Utility.RandomInt(1,100) <= 25 
				CrateContainer.AddItem(LItemBlacksmithMineralsProcessed75,1 *Size,true)
			else
				CrateContainer.AddItem(LItemBlacksmithMineralsRaw75,6 *Size,true)
			endIf
		elseIf Game.FindClosestReferenceOfAnyTypeInListFromRef(wizCookingPotList, self, 1000) != None
			;Cooking pots
			if Utility.RandomInt(1,100) <= 25 
				CrateContainer.AddItem(LItemFoodFishList,1 *Size,true)
				CrateContainer.AddItem(LItemFoodSalt,1 *Size,true)
			else
				if Compatibility.isRND
					;RND is installed so use stale food!
					CrateContainer.RemoveAllItems()
					CrateContainer.addItem(Game.GetFormFromFile(0x01007F55, "RealisticNeedsandDiseases.esp") AS LeveledItem) ;RND_LItemBarrelFoodStale50
					CrateContainer.addItem(Game.GetFormFromFile(0x01007F63, "RealisticNeedsandDiseases.esp") AS LeveledItem) ;RND_LItemBarrelFoodRawMeatSame10
					CrateContainer.addItem(Game.GetFormFromFile(0x01007F65, "RealisticNeedsandDiseases.esp") AS LeveledItem) ;RND_LItemMiscItem50
					CrateContainer.addItem(Game.GetFormFromFile(0x01007F65, "RealisticNeedsandDiseases.esp") AS LeveledItem) ;RND_LItemMiscItem50
				else
					CrateContainer.AddItem(LItemFoodRawMeat,5 *Size,true)
					CrateContainer.AddItem(LItemFoodSalt,1 *Size,true)
				endIf
			endIf
		else
			;Randomize the barrel
			if Utility.RandomInt(1,100) <= 50
				CrateContainer.AddItem(LItemFurnitureMiscItems75,6 *Size,true)
			else
				CrateContainer.AddItem(LItemMiscVendorClothing75,6 *Size,true)
			endIf
		endIf

		;Make barrel container owned???
		if  self.getcurrentlocation() && self.getcurrentlocation().haskeyword(Keyword.getkeyword("LocTypeHabitation"))
			CrateContainer.SetActorOwner(ArngeirREF.GetActorBase())
		endIf

		utility.wait(1) ;This should help reduce flicker

		;Check for parent issue
		
		If ParentIssues != TRUE && !wizParentIssues.HasForm(ClosestCrate)
			ClosestCrate.disable()
			if !ClosestCrate.IsDisabled()
				;This catches parent problems and add it to an ignore list to prevent
				debug.trace ("********** wizDYNAMIC THINGS - The Enable State Parent error above has been accounted for and will not occur again for this object **********")
				ParentIssues = TRUE
				ClosestCrate.moveto(ClosestCrate,0,0,-1000,true)
				;Add to parent issues for logging!
				if !(wizParentIssues.HasForm(ClosestCrate)) 
					wizParentIssues.AddForm(ClosestCrate)
				endIf
;				debug.messagebox(ClosestCrate)
			endIf
		else
			;Known parent issues!
			ParentIssues = TRUE
		endIf
		

EndFunction