Scriptname wizDriftWoodMarkerScript extends ObjectReference  

;This is only used to disable the bush and regrow it later

FormList Property wizDriftWoodList Auto
GlobalVariable Property wizOptionDTResetTime Auto
Static Property CoastDriftWood01 Auto
Static Property CoastDriftWood02 Auto
Static Property CoastDriftWood03 Auto
Activator Property wizCoastDriftWood01a Auto
Activator Property wizCoastDriftWood02a Auto
Activator Property wizCoastDriftWood03a Auto
Static Property TreeReachBranchPile01 Auto
Static Property TreeReachBranchPile02 Auto
Activator Property wizTreeReachBranchPile01a Auto
Activator Property wizTreeReachBranchPile02a Auto


Float ResetTime
Float originalScale
objectReference ClosestDriftWood
objectReference wizDriftWood
bool Harvested
bool ParentIssues 

event onInit()

	if ClosestDriftWood== None ;First Once
		ClosestDriftWood= Game.FindClosestReferenceOfAnyTypeInListFromRef(wizDriftWoodList, self, 15)
	
		if ClosestDriftWood
			;Find out which driftwood
			if ClosestDriftWood.GetBaseObject() == CoastDriftWood01 
				wizDriftWood = self.placeatme(wizCoastDriftWood01a)
			elseIf ClosestDriftWood.GetBaseObject() == CoastDriftWood02
				wizDriftWood = self.placeatme(wizCoastDriftWood02a)
			elseIf ClosestDriftWood.GetBaseObject() == CoastDriftWood03
				wizDriftWood = self.placeatme(wizCoastDriftWood03a)
			elseIf ClosestDriftWood.GetBaseObject() == TreeReachBranchPile01 
				wizDriftWood = self.placeatme(wizTreeReachBranchPile01a)
			elseIf ClosestDriftWood.GetBaseObject() == TreeReachBranchPile02
				wizDriftWood = self.placeatme(wizTreeReachBranchPile02a)
			else
				;No original?
				self.disable()
				self.delete()
				return
			endIf


			;Set the angles!
			wizDriftWood.SetAngle(ClosestDriftWood.GetAngleX(), ClosestDriftWood.GetAngleY(), ClosestDriftWood.GetAngleZ())
			;Set the Scale!
;			wizDriftWood.SetScale(ClosestDriftWood.getscale())
			wizDriftWood.SetScale(0.05)

			originalScale= ClosestDriftWood.getScale()

			;Test for parent issues
			ClosestDriftWood.disable()
						
			if !ClosestDriftWood.isDisabled()
				;This catches parent problems and add it to an ignore list to prevent
				debug.trace ("********** wizDYNAMIC THINGS - The Enable State Parent error above has been accounted for and will not occur again for this object **********")
				ParentIssues = TRUE
				ClosestDriftWood.setscale(0.05)
			else
				ClosestDriftWood.enable()
			endIf
		else
			;No driftwood?
			self.disable()
			self.delete()
			return
		endIf

		ResetTime = Utility.GetCurrentGameTime()
	endIf

endEvent

Event OnCellDetach()
	if wizDriftWood.isDisabled()
		Harvested = True
	else
		Harvested = False
		wizDriftWood.disable()
	endIf
	
	;Restore bush
	if ParentIssues != TRUE
		ClosestDriftWood.enable()
	else
		ClosestDriftWood.setscale(originalScale)
	endIf

	ResetTime = Utility.GetCurrentGameTime() 

endEvent


Event OnCellAttach()
	;Are we past the reset time?
	
	if utility.getCurrentGameTime() >= (ResetTime+ (wizOptionDTResetTime.getvalue() as float))
		wizDriftWood.disable()
		wizDriftWood.delete()
		;Leave visible and delete this marker
		self.disable()
		self.delete()
	else
		;Still not reset
		if ClosestDriftWood
			if Harvested == TRUE
				;Hide driftwood
				if ParentIssues != TRUE
					ClosestDriftWood.disable()
				else
					ClosestDriftWood.setscale(0.05)
				endIf
			else
				;Show wizDriftWood
				wizDriftWood.enable()
			endIf
		else
			;No driftwood?
			wizDriftWood.disable()
			wizDriftWood.delete()
			self.disable()
			self.delete()
		endIf

	endIf
endEvent


