Scriptname wizDTCompatibility extends ReferenceAlias  

;Thanks Chesko ;-)

Actor Property playerREF Auto
FormList Property WoodChoppingAxes Auto
Weapon Property Axe01 Auto

;#Official DLC=================================================================
bool property isDLC1Loaded auto hidden						;Dawnguard
bool property isDLC2Loaded auto hidden						;Dragonborn
bool property isDLC3Loaded auto hidden						;????
bool property isDLC4Loaded auto hidden						;????
bool property isHFLoaded auto hidden						;Hearthfire

;#Supported Mods===============================================================
bool property isSKSELoaded auto hidden						;SKSE
bool property isSKYUILoaded auto hidden						;SkyUI 3.0+
bool property isPlaceableStatics auto hidden				;Placeable Statics
bool property isRND auto hidden								;Realistic Needs and Diseases
bool property isFrostfall auto hidden						;Frostfall
bool property isSFODiversity auto Hidden					;Skyrim Flora Overhaul - Expanded Diversity

;#FormLists====================================================================
formlist property wizWoodPile auto							;All wood piles
formlist property wizWoodPileContainers auto					;All wood piles
formlist property wizWoodPileHugeList auto					;All wood piles
formlist property wizWoodPileLargeList auto					;All wood piles
formlist property wizWoodPileMediumList auto					;All wood piles
formlist property wizWoodPileSmallList auto					;All wood piles
formlist property wizBarrelList auto							;All barrels
formlist property wizCrateList auto							;All crates
FormList Property wizCrateSmallList Auto
FormList Property wizCrateLongList Auto
FormList Property wizCrateSmall01List Auto
FormList Property wizCrateSmall01WeatheredList Auto
FormList Property wizCrateSmall02List Auto
FormList Property wizCrateSmall02WeatheredList Auto
FormList Property wizCrateSmall03List Auto
FormList Property wizCrateSmall03WeatheredList Auto
FormList Property wizCrateSmall04List Auto
FormList Property wizCrateSmall04WeatheredList Auto
FormList Property wizCrateSmallLong01List Auto
FormList Property wizCrateSmallLong01WeatheredList Auto
FormList Property wizCrateSmallLong02List Auto
FormList Property wizCrateSmallLong02WeatheredList Auto
FormList Property wizCrateSmallLong03List Auto
FormList Property wizCrateSmallLong03WeatheredList Auto
FormList Property wizCrateSmallLong04List Auto
FormList Property wizCrateSmallLong04WeatheredList Auto
FormList Property wizBreweryCasks Auto
FormList Property wizStrawList Auto
FormList Property wizMeadBarrel01List Auto
FormList Property wizMiscConversionList Auto
FormList Property EmptyBottles Auto
FormList Property wizMeadBarrelBloodList Auto
FormList Property wizArcheryTargetList Auto
FormList Property wizCombatDummyList Auto
FormList Property wizCombatDummy01 Auto
FormList Property wizCombatDummy02 Auto
FormList Property wizCombatDummy03 Auto
FormList Property wizBushList Auto
FormList Property wizTreeList Auto
FormList Property wizRockList Auto

;#Frostfall Wood Cutter's Axes =====================================================
weapon property _DE_Axe01_0 auto hidden
weapon property _DE_Axe01_1 auto hidden
weapon property _DE_Axe01_2 auto hidden
weapon property _DE_Axe01_3 auto hidden
weapon property _DE_Axe01_4 auto hidden
weapon property _DE_Axe01_5 auto hidden
weapon property _DE_Axe01_6 auto hidden
weapon property _DE_Axe01_7 auto hidden
weapon property _DE_Axe01_8 auto hidden
weapon property _DE_Axe01_9 auto hidden
weapon property _DE_Axe01_10 auto hidden
weapon property _DE_Axe01_11 auto hidden
weapon property _DE_Axe01_12 auto hidden
weapon property _DE_Axe01_13 auto hidden
weapon property _DE_Axe01_14 auto hidden
MiscObject property _DE_AxeBroken auto hidden
MiscObject property _DE_DeadWood auto hidden

Event OnInit()
	RunStartupCheck()
endEvent

Event OnPlayerLoadGame()
;	debug.notification("Compatibility started " + isPlaceableStatics)
	RunStartupCheck()
endEvent

function RunStartupCheck()
	if isSKSELoaded
		isSKSELoaded = SKSE.GetVersion()
		if !isSKSELoaded
			;SKSE was removed since the last save.
			;Turn off SKSE-only features - none at this time
		else

		endif
	else
		isSKSELoaded = SKSE.GetVersion()
		if isSKSELoaded
			;SKSE was just added.

		else
			;Turn off SKSE-only features - none at this time

		endif
	endif
	
	if isSKYUILoaded
		isSKYUILoaded = Game.GetFormFromFile(0x01000814, "SkyUI.esp")
		if !isSKYUILoaded
			;SkyUI was removed since the last save.
		endif
	else
		isSKYUILoaded = Game.GetFormFromFile(0x01000814, "SkyUI.esp")
		if isSKYUILoaded
			;SkyUI was just loaded.
		endif
	endif

	if isDLC1Loaded && wizRockList.HasForm(Game.GetFormFromFile(0x02005892, "Dawnguard.esm"))
		isDLC1Loaded = Game.GetFormFromFile(0x02005892, "Dawnguard.esm")
		if !isDLC1Loaded
			;DLC1 was removed since the last save.

		else
		endif
	else
		isDLC1Loaded = Game.GetFormFromFile(0x02005892, "Dawnguard.esm")
		if isDLC1Loaded
			;DLC1 was just added.
			if !(EmptyBottles.HasForm(Game.GetFormFromFile(0x010093F5, "Dawnguard.esm")))
				EmptyBottles.AddForm(Game.GetFormFromFile(0x010093F5, "Dawnguard.esm"))			;Empty Bottles
				EmptyBottles.AddForm(Game.GetFormFromFile(0x010093F6, "Dawnguard.esm"))			;Empty Bottles
			endif		
			if !(wizMeadBarrelBloodList.HasForm(Game.GetFormFromFile(0x0100482D, "Dawnguard.esm")))
				wizMeadBarrelBloodList.AddForm(Game.GetFormFromFile(0x0100482D, "Dawnguard.esm"))	;MeadBarrel_BloodDrip01
				wizMeadBarrelBloodList.AddForm(Game.GetFormFromFile(0x01004847, "Dawnguard.esm"))		;MeadBarrel_BloodDrip02
			endif		
			if !(wizMiscConversionList.HasForm(Game.GetFormFromFile(0x0100482D, "Dawnguard.esm")))
				wizMiscConversionList.AddForm(Game.GetFormFromFile(0x0100482D, "Dawnguard.esm"))		;MeadBarrel_BloodDrip01
				wizMiscConversionList.AddForm(Game.GetFormFromFile(0x01004847, "Dawnguard.esm"))		;MeadBarrel_BloodDrip02
			endif
			if !(wizBushList.HasForm(Game.GetFormFromFile(0x0200B55D, "Dawnguard.esm")))
				wizBushList.AddForm(Game.GetFormFromFile(0x0200B55D, "Dawnguard.esm"))		;DLC1BushDeadSnowH01
				wizBushList.AddForm(Game.GetFormFromFile(0x0200B55E, "Dawnguard.esm"))		;DLC1FallenBranchSnowH01
				wizBushList.AddForm(Game.GetFormFromFile(0x0201659B, "Dawnguard.esm"))		;DLC1PPVineCeiling01NoCol1
				wizBushList.AddForm(Game.GetFormFromFile(0x0201659A, "Dawnguard.esm"))		;DLC1PPVineFloor
				wizBushList.AddForm(Game.GetFormFromFile(0x02016599, "Dawnguard.esm"))		;DLC1PPVineFloor01NoCol1
				wizBushList.AddForm(Game.GetFormFromFile(0x02016598, "Dawnguard.esm"))		;DLC1PPVineFloor02NoCol
				wizBushList.AddForm(Game.GetFormFromFile(0x0201659C, "Dawnguard.esm"))		;DLC1PPVineWall01
				wizBushList.AddForm(Game.GetFormFromFile(0x0201659D, "Dawnguard.esm"))		;DLC1PPVineWall01NoCol
				wizBushList.AddForm(Game.GetFormFromFile(0x0201659E, "Dawnguard.esm"))		;DLC1PPVineWall02
				wizBushList.AddForm(Game.GetFormFromFile(0x0201659F, "Dawnguard.esm"))		;DLC1PPVineWall02NoCol
				wizBushList.AddForm(Game.GetFormFromFile(0x020165A0, "Dawnguard.esm"))		;DLC1PPVineWall03
				wizBushList.AddForm(Game.GetFormFromFile(0x020165A1, "Dawnguard.esm"))		;DLC1PPVineWall03NoCol
				wizBushList.AddForm(Game.GetFormFromFile(0x0200431D, "Dawnguard.esm"))		;DLC1TreeDeadVineHallway
				wizBushList.AddForm(Game.GetFormFromFile(0x02004321, "Dawnguard.esm"))		;DLC1TreeDeadVineHallwayAsh
				wizBushList.AddForm(Game.GetFormFromFile(0x0200431E, "Dawnguard.esm"))		;DLC1TreeDeadVineLong
				wizBushList.AddForm(Game.GetFormFromFile(0x02004322, "Dawnguard.esm"))		;DLC1TreeDeadVineLongAsh
				wizBushList.AddForm(Game.GetFormFromFile(0x0200431F, "Dawnguard.esm"))		;DLC1TreeDeadVinePatch
				wizBushList.AddForm(Game.GetFormFromFile(0x02004320, "Dawnguard.esm"))		;DLC1TreeDeadVinePatchAsh
				wizBushList.AddForm(Game.GetFormFromFile(0x020042E3, "Dawnguard.esm"))		;DLC1TreeIceVineHallway
				wizBushList.AddForm(Game.GetFormFromFile(0x020042E8, "Dawnguard.esm"))		;DLC1TreeIceVineHallwaySnow
				wizBushList.AddForm(Game.GetFormFromFile(0x020042E1, "Dawnguard.esm"))		;DLC1TreeIceVineLong
				wizBushList.AddForm(Game.GetFormFromFile(0x020042E9, "Dawnguard.esm"))		;DLC1TreeIceVineLongSnow
				wizBushList.AddForm(Game.GetFormFromFile(0x020042E2, "Dawnguard.esm"))		;DLC1TreeIceVinePatch
				wizBushList.AddForm(Game.GetFormFromFile(0x020042EA, "Dawnguard.esm"))		;DLC1TreeIceVinePatchSnow
				wizBushList.AddForm(Game.GetFormFromFile(0x02003BD9, "Dawnguard.esm"))		;DLC1SoulCairnShrub01
				wizBushList.AddForm(Game.GetFormFromFile(0x02003BDA, "Dawnguard.esm"))		;DLC1SoulCairnShrub02
				wizBushList.AddForm(Game.GetFormFromFile(0x02003BDB, "Dawnguard.esm"))		;DLC1SoulCairnShrub03
				wizBushList.AddForm(Game.GetFormFromFile(0x02011D54, "Dawnguard.esm"))		;DLC1SoulCairnShrubGroup01
				wizBushList.AddForm(Game.GetFormFromFile(0x02011D55, "Dawnguard.esm"))		;DLC1SoulCairnShrubGroup02
;				wizBushList.AddForm(Game.GetFormFromFile(0x02004332, "Dawnguard.esm"))		;DLC1SoulCairnTree01
;				wizBushList.AddForm(Game.GetFormFromFile(0x02004333, "Dawnguard.esm"))		;DLC1SoulCairnTree02
;				wizBushList.AddForm(Game.GetFormFromFile(0x02004334, "Dawnguard.esm"))		;DLC1SoulCairnTree03
;				wizBushList.AddForm(Game.GetFormFromFile(0x0200DDB5, "Dawnguard.esm"))		;DLC1SoulCairnTreeGroup
			endIf
			if !(wizTreeList.HasForm(Game.GetFormFromFile(0x02009670, "Dawnguard.esm")))
				wizTreeList.AddForm(Game.GetFormFromFile(0x02009670, "Dawnguard.esm"))		;DLC1TreePineForestSnowHeavy01
				wizTreeList.AddForm(Game.GetFormFromFile(0x0200B55F, "Dawnguard.esm"))		;DLC1TreePineForestSnowHeavy02
				wizTreeList.AddForm(Game.GetFormFromFile(0x02003AC5, "Dawnguard.esm"))		;TreeWinterAspen01
				wizTreeList.AddForm(Game.GetFormFromFile(0x02003AC9, "Dawnguard.esm"))		;TreeWinterAspen02
				wizTreeList.AddForm(Game.GetFormFromFile(0x02003ACA, "Dawnguard.esm"))		;TreeWinterAspen03
				wizTreeList.AddForm(Game.GetFormFromFile(0x02003ACB, "Dawnguard.esm"))		;TreeWinterAspen04
				wizTreeList.AddForm(Game.GetFormFromFile(0x02003ACC, "Dawnguard.esm"))		;TreeWinterAspen05
				wizTreeList.AddForm(Game.GetFormFromFile(0x02003ACF, "Dawnguard.esm"))		;TreeWinterAspen06
				wizTreeList.AddForm(Game.GetFormFromFile(0x02004332, "Dawnguard.esm"))		;TreeSoulCairnTree01
				wizTreeList.AddForm(Game.GetFormFromFile(0x02004333, "Dawnguard.esm"))		;TreeSoulCairnTree02
				wizTreeList.AddForm(Game.GetFormFromFile(0x02004334, "Dawnguard.esm"))		;TreeSoulCairnTree03
				wizTreeList.AddForm(Game.GetFormFromFile(0x0200DDB5, "Dawnguard.esm"))		;TreeSoulCairnTreeGroup
			endIf
			if !(wizRockList.HasForm(Game.GetFormFromFile(0x02005892, "Dawnguard.esm")))
				wizRockList.AddForm(Game.GetFormFromFile(0x02005892, "Dawnguard.esm"))		;Rock Pile Soul Cairn
				wizRockList.AddForm(Game.GetFormFromFile(0x02005894, "Dawnguard.esm"))		;Rock Pile Soul Cairn
				wizRockList.AddForm(Game.GetFormFromFile(0x02005896, "Dawnguard.esm"))		;Rock Pile Soul Cairn
				wizRockList.AddForm(Game.GetFormFromFile(0x0200E9E9, "Dawnguard.esm"))		;Rock Pile Soul Cairn
				wizRockList.AddForm(Game.GetFormFromFile(0x02005899, "Dawnguard.esm"))		;Rock Pile Soul Cairn
				wizRockList.AddForm(Game.GetFormFromFile(0x0200589B, "Dawnguard.esm"))		;Rock Pile Soul Cairn
				wizRockList.AddForm(Game.GetFormFromFile(0x0200589C, "Dawnguard.esm"))		;Rock Pile Soul Cairn
				wizRockList.AddForm(Game.GetFormFromFile(0x0200E9E8, "Dawnguard.esm"))		;Rock Pile Soul Cairn
				wizRockList.AddForm(Game.GetFormFromFile(0x02011858, "Dawnguard.esm"))		;Rock Pile Soul Cairn
				wizRockList.AddForm(Game.GetFormFromFile(0x02011810, "Dawnguard.esm"))		;Rock Pile Soul Cairn
				wizRockList.AddForm(Game.GetFormFromFile(0x02013260, "Dawnguard.esm"))		;Rock Pile Soul Cairn
				wizRockList.AddForm(Game.GetFormFromFile(0x02011811, "Dawnguard.esm"))		;Rock Pile Soul Cairn
				wizRockList.AddForm(Game.GetFormFromFile(0x02011C42, "Dawnguard.esm"))		;Rock Pile Soul Cairn
				wizRockList.AddForm(Game.GetFormFromFile(0x02011813, "Dawnguard.esm"))		;Rock Pile Soul Cairn
				wizRockList.AddForm(Game.GetFormFromFile(0x02011812, "Dawnguard.esm"))		;Rock Pile Soul Cairn
				wizRockList.AddForm(Game.GetFormFromFile(0x02011C41, "Dawnguard.esm"))		;Rock Pile Soul Cairn
				wizRockList.AddForm(Game.GetFormFromFile(0x02013247, "Dawnguard.esm"))		;Rock Pile Soul Cairn
				wizRockList.AddForm(Game.GetFormFromFile(0x0201327D, "Dawnguard.esm"))		;Rock Pile Soul Cairn
				wizRockList.AddForm(Game.GetFormFromFile(0x02013277, "Dawnguard.esm"))		;Rock Pile Soul Cairn
				wizRockList.AddForm(Game.GetFormFromFile(0x0201181C, "Dawnguard.esm"))		;Rock Pile Soul Cairn
			endif

			debug.notification("Dynamic Things - Support for Dawnguard added")				
		else

		endif
	endif
	
	if isDLC2Loaded && wizRockList.HasForm(Game.GetFormFromFile(0x0201E0B0, "Dragonborn.esm"))
		isDLC2Loaded = Game.GetFormFromFile(0x0201E0B0, "Dragonborn.esm")
		if !isDLC2Loaded
			;DLC2 was removed since the last save.

		else
		endif
	else
		isDLC2Loaded = Game.GetFormFromFile(0x0201FB99, "Dragonborn.esm")
		if isDLC2Loaded
			;DLC2 was just added.
			if !(wizTreeList.HasForm(Game.GetFormFromFile(0x02017F76, "Dragonborn.esm")))
				wizTreeList.AddForm(Game.GetFormFromFile(0x02017F76, "Dragonborn.esm"))	;<DLC2TreePineForestAsh05>
				wizTreeList.AddForm(Game.GetFormFromFile(0x02017F75, "Dragonborn.esm"))	;<DLC2TreePineForestAsh04>
				wizTreeList.AddForm(Game.GetFormFromFile(0x02017F74, "Dragonborn.esm"))	;<DLC2TreePineForestAsh03>
				wizTreeList.AddForm(Game.GetFormFromFile(0x02017F73, "Dragonborn.esm"))	;<DLC2TreePineForestAsh02>
				wizTreeList.AddForm(Game.GetFormFromFile(0x02017F72, "Dragonborn.esm"))	;<DLC2TreePineForestAsh01>
				wizTreeList.AddForm(Game.GetFormFromFile(0x02017F71, "Dragonborn.esm"))	;<DLC2TreePineForestAshL05>
				wizTreeList.AddForm(Game.GetFormFromFile(0x02017F70, "Dragonborn.esm"))	;<DLC2TreePineForestAshL04>
				wizTreeList.AddForm(Game.GetFormFromFile(0x02017F6F, "Dragonborn.esm"))	;<DLC2TreePineForestAshL03>
				wizTreeList.AddForm(Game.GetFormFromFile(0x02017F6E, "Dragonborn.esm"))	;<DLC2TreePineForestAshL01>
				wizTreeList.AddForm(Game.GetFormFromFile(0x02017F6D, "Dragonborn.esm"))	;<DLC2TreePineForestAshL02>
				wizTreeList.AddForm(Game.GetFormFromFile(0x02017F62, "Dragonborn.esm"))	;<DLC2TreePineForestDeadAshL05>
				wizTreeList.AddForm(Game.GetFormFromFile(0x02017F60, "Dragonborn.esm"))	;<DLC2TreePineForestDeadAshL04>
				wizTreeList.AddForm(Game.GetFormFromFile(0x02017F5C, "Dragonborn.esm"))	;<DLC2TreePineForestDeadAshL03>
				wizTreeList.AddForm(Game.GetFormFromFile(0x02017F5B, "Dragonborn.esm"))	;<DLC2TreePineForestDeadAshL02>
				wizTreeList.AddForm(Game.GetFormFromFile(0x02017F5A, "Dragonborn.esm"))	;<DLC2TreePineForestDeadAshL01>
				wizTreeList.AddForm(Game.GetFormFromFile(0x020195E8, "Dragonborn.esm"))	;<DLC2TreePineForestBroken01>
				wizTreeList.AddForm(Game.GetFormFromFile(0x020195F0, "Dragonborn.esm"))	;<DLC2TreePineForestBroken01Ash>
				wizTreeList.AddForm(Game.GetFormFromFile(0x020195EB, "Dragonborn.esm"))	;<DLC2TreePineForestBroken02>
				wizTreeList.AddForm(Game.GetFormFromFile(0x02017F77, "Dragonborn.esm"))	;<DLC2TreePineForestBroken04>
				wizTreeList.AddForm(Game.GetFormFromFile(0x020185E5, "Dragonborn.esm"))	;<DLC2TreePineForestBroken05>
				wizTreeList.AddForm(Game.GetFormFromFile(0x0201D500, "Dragonborn.esm"))	;<DLC2TreePineForestBroken06>
				wizTreeList.AddForm(Game.GetFormFromFile(0x0201D4F7, "Dragonborn.esm"))	;<DLC2TreePineForestBrokenCluster01>
				wizTreeList.AddForm(Game.GetFormFromFile(0x0201D73A, "Dragonborn.esm"))	;<DLC2TreePineForestBrokenSmoking01>
				wizTreeList.AddForm(Game.GetFormFromFile(0x020185EE, "Dragonborn.esm"))	;<DLC2TreePineForestHollow01Ash>
				wizTreeList.AddForm(Game.GetFormFromFile(0x02017F6A, "Dragonborn.esm"))	;<DLC2TreePineForestHollow01AshL>
				wizTreeList.AddForm(Game.GetFormFromFile(0x020185EF, "Dragonborn.esm"))	;<DLC2TreePineForestLog01Ash>
				wizTreeList.AddForm(Game.GetFormFromFile(0x02017F68, "Dragonborn.esm"))	;<DLC2TreePineForestLog01AshL>
				wizTreeList.AddForm(Game.GetFormFromFile(0x020185F0, "Dragonborn.esm"))	;<DLC2TreePineForestLog02Ash>
				wizTreeList.AddForm(Game.GetFormFromFile(0x02017F67, "Dragonborn.esm"))	;<DLC2TreePineForestLog02AshL>
				wizTreeList.AddForm(Game.GetFormFromFile(0x020185ED, "Dragonborn.esm"))	;<DLC2TreePineForestStump01Ash>
				wizTreeList.AddForm(Game.GetFormFromFile(0x02017F64, "Dragonborn.esm"))	;<DLC2TreePineForestStump01AshL>
			endIf
			if !(wizBushList.HasForm(Game.GetFormFromFile(0x02019B16, "Dragonborn.esm")))
				wizBushList.AddForm(Game.GetFormFromFile(0x02019B16, "Dragonborn.esm"))	;DLC2TreeDeadShrubAsh
				wizBushList.AddForm(Game.GetFormFromFile(0x02019C5E, "Dragonborn.esm"))	;DLC2TreePineShrubAsh01
				wizBushList.AddForm(Game.GetFormFromFile(0x02019C60, "Dragonborn.esm"))	;DLC2TreePineShrubAsh02
				wizBushList.AddForm(Game.GetFormFromFile(0x02019C5F, "Dragonborn.esm"))	;DLC2TreePineShrubAsh03
				wizBushList.AddForm(Game.GetFormFromFile(0x02019C5B, "Dragonborn.esm"))	;DLC2TreeThicketAsh01
			EndIf
			if !(wizRockList.HasForm(Game.GetFormFromFile(0x0201E0B0, "Dragonborn.esm")))
				wizRockList.AddForm(Game.GetFormFromFile(0x0201E0B0, "Dragonborn.esm"))		;DLC2 Rocks
				wizRockList.AddForm(Game.GetFormFromFile(0x0201E0B1, "Dragonborn.esm"))		;DLC2 Rocks
				wizRockList.AddForm(Game.GetFormFromFile(0x0201E0B2, "Dragonborn.esm"))		;DLC2 Rocks
				wizRockList.AddForm(Game.GetFormFromFile(0x0201E0B3, "Dragonborn.esm"))		;DLC2 Rocks
				wizRockList.AddForm(Game.GetFormFromFile(0x0201E0B4, "Dragonborn.esm"))		;DLC2 Rocks
				wizRockList.AddForm(Game.GetFormFromFile(0x02019A27, "Dragonborn.esm"))		;DLC2 Rocks
				wizRockList.AddForm(Game.GetFormFromFile(0x02019A29, "Dragonborn.esm"))		;DLC2 Rocks
				wizRockList.AddForm(Game.GetFormFromFile(0x02019A2D, "Dragonborn.esm"))		;DLC2 Rocks
				wizRockList.AddForm(Game.GetFormFromFile(0x02019A2F, "Dragonborn.esm"))		;DLC2 Rocks
				wizRockList.AddForm(Game.GetFormFromFile(0x02016E0F, "Dragonborn.esm"))		;DLC2 Rocks
				wizRockList.AddForm(Game.GetFormFromFile(0x0202B82E, "Dragonborn.esm"))		;DLC2 Rocks
				wizRockList.AddForm(Game.GetFormFromFile(0x02016E13, "Dragonborn.esm"))		;DLC2 Rocks
				wizRockList.AddForm(Game.GetFormFromFile(0x0201BE28, "Dragonborn.esm"))		;DLC2 Rocks
				wizRockList.AddForm(Game.GetFormFromFile(0x02016E0D, "Dragonborn.esm"))		;DLC2 Rocks
				wizRockList.AddForm(Game.GetFormFromFile(0x02038AF7, "Dragonborn.esm"))		;DLC2 Rocks
				wizRockList.AddForm(Game.GetFormFromFile(0x02016E11, "Dragonborn.esm"))		;DLC2 Rocks
				wizRockList.AddForm(Game.GetFormFromFile(0x0201BE26, "Dragonborn.esm"))		;DLC2 Rocks
				wizRockList.AddForm(Game.GetFormFromFile(0x02016E0A, "Dragonborn.esm"))		;DLC2 Rocks
				wizRockList.AddForm(Game.GetFormFromFile(0x02029F23, "Dragonborn.esm"))		;DLC2 Rocks
				wizRockList.AddForm(Game.GetFormFromFile(0x02029F24, "Dragonborn.esm"))		;DLC2 Rocks
				wizRockList.AddForm(Game.GetFormFromFile(0x02029F25, "Dragonborn.esm"))		;DLC2 Rocks
				wizRockList.AddForm(Game.GetFormFromFile(0x02029F28, "Dragonborn.esm"))		;DLC2 Rocks
				wizRockList.AddForm(Game.GetFormFromFile(0x02029F2B, "Dragonborn.esm"))		;DLC2 Rocks
				wizRockList.AddForm(Game.GetFormFromFile(0x0201E0B7, "Dragonborn.esm"))		;DLC2 Rocks
				wizRockList.AddForm(Game.GetFormFromFile(0x0201E0B8, "Dragonborn.esm"))		;DLC2 Rocks
				wizRockList.AddForm(Game.GetFormFromFile(0x0201E0B9, "Dragonborn.esm"))		;DLC2 Rocks
			EndIf
			debug.notification("Dynamic Things - Support for Dragonborn added")
		else

		endif
	endif
		
	if isSFODiversity && (wizTreeList.HasForm(Game.GetFormFromFile(0x01000D62, "SFO - Expanded Diversity.esp")))
		isSFODiversity = Game.GetFormFromFile(0x01000D62, "SFO - Expanded Diversity.esp")
		if !isSFODiversity
			;SFO - Diversity was removed since the last save.

		else
		endif
	else
		isSFODiversity = Game.GetFormFromFile(0x01000D62, "SFO - Expanded Diversity.esp")
		if isSFODiversity
			;SFO - Diversity was just added.
			if !(wizTreeList.HasForm(Game.GetFormFromFile(0x01000D62, "SFO - Expanded Diversity.esp")))
				wizTreeList.AddForm(Game.GetFormFromFile(0x01000D62, "SFO - Expanded Diversity.esp"))			;Vurt - Aspen
				wizTreeList.AddForm(Game.GetFormFromFile(0x01004543, "SFO - Expanded Diversity.esp"))			;Vurt - Dead Tree 01
				wizTreeList.AddForm(Game.GetFormFromFile(0x01004544, "SFO - Expanded Diversity.esp"))			;Vurt - Dead Tree 02
				wizTreeList.AddForm(Game.GetFormFromFile(0x01004AB7, "SFO - Expanded Diversity.esp"))			;Vurt - Bristlecone Pine
				wizTreeList.AddForm(Game.GetFormFromFile(0x01005B90, "SFO - Expanded Diversity.esp"))			;Vurt - Bent Pine
				wizTreeList.AddForm(Game.GetFormFromFile(0x01005BF3, "SFO - Expanded Diversity.esp"))			;Vurt - Maple Tree
			endif		
			debug.notification("Dynamic Things - Support for SFO - Expanded Diversity added")			
		endif
	endif

	if isHFLoaded && (wizStrawList.HasForm(Game.GetFormFromFile(0x01005A68, "HearthFires.esm")))
		isHFLoaded = Game.GetFormFromFile(0x01005A68, "HearthFires.esm")
		if !isHFLoaded
			;HF was removed since the last save.

		else
		endif
	else
		isHFLoaded = Game.GetFormFromFile(0x01005A68, "HearthFires.esm")
		if isHFLoaded
			;HF was just added.
			if !(wizStrawList.HasForm(Game.GetFormFromFile(0x01005A68, "HearthFires.esm")))
				wizStrawList.AddForm(Game.GetFormFromFile(0x01005A68, "HearthFires.esm"))			;Misc Item - Straw
			endif		
			debug.notification("Dynamic Things - Support for Hearthfire added")			
		endif
	endif

	if isRND
		isRND= Game.GetFormFromFile(0x010043B0, "RealisticNeedsandDiseases.esp")
		if !isRND
			;RND was removed since the last save.

		else
		endif
	else
		isRND= Game.GetFormFromFile(0x010043B0, "RealisticNeedsandDiseases.esp")
		if isRND
			;RND was just added.
			if !(EmptyBottles.HasForm(Game.GetFormFromFile(0x010043B0, "RealisticNeedsandDiseases.esp")))
				EmptyBottles.AddForm(Game.GetFormFromFile(0x010043B0, "RealisticNeedsandDiseases.esp"))			;Empty Bottles
				EmptyBottles.AddForm(Game.GetFormFromFile(0x010043B2, "RealisticNeedsandDiseases.esp"))			;Empty Bottles
				EmptyBottles.AddForm(Game.GetFormFromFile(0x010043B4, "RealisticNeedsandDiseases.esp"))			;Empty Bottles
			endif		
			debug.notification("Dynamic Things - Support for RND added")		
		endif
	endif

	if isFrostfall && _DE_DeadWood
		isFrostfall= Game.GetFormFromFile(0x0102564C, "Chesko_Frostfall.esp") ;Deadwood
		if !isFrostfall
			;Frostfall was removed since the last save.

		else
		endif
	else
		isFrostfall = Game.GetFormFromFile(0x0102564C, "Chesko_Frostfall.esp")
		if isFrostfall
			;Frostfall was just added.
			_DE_Axe01_0 = Game.GetFormFromFile(0x0302A742, "Chesko_Frostfall.esp") as Weapon				;_DE_Axe01_0
			_DE_Axe01_1 = Game.GetFormFromFile(0x0302A743, "Chesko_Frostfall.esp") as Weapon				;_DE_Axe01_1
			_DE_Axe01_2 = Game.GetFormFromFile(0x0302A744, "Chesko_Frostfall.esp") as Weapon				;_DE_Axe01_2
			_DE_Axe01_3 = Game.GetFormFromFile(0x0302A745, "Chesko_Frostfall.esp") as Weapon				;_DE_Axe01_3
			_DE_Axe01_4 = Game.GetFormFromFile(0x0302A746, "Chesko_Frostfall.esp") as Weapon				;_DE_Axe01_4
			_DE_Axe01_5 = Game.GetFormFromFile(0x0302A747, "Chesko_Frostfall.esp") as Weapon				;_DE_Axe01_5
			_DE_Axe01_6 = Game.GetFormFromFile(0x0302A748, "Chesko_Frostfall.esp") as Weapon				;_DE_Axe01_6
			_DE_Axe01_7 = Game.GetFormFromFile(0x0302A749, "Chesko_Frostfall.esp") as Weapon				;_DE_Axe01_7
			_DE_Axe01_8 = Game.GetFormFromFile(0x0302A74A, "Chesko_Frostfall.esp") as Weapon				;_DE_Axe01_8
			_DE_Axe01_9 = Game.GetFormFromFile(0x0302A74B, "Chesko_Frostfall.esp") as Weapon				;_DE_Axe01_9
			_DE_Axe01_10 = Game.GetFormFromFile(0x0302A74C, "Chesko_Frostfall.esp") as Weapon			;_DE_Axe01_10
			_DE_Axe01_11 = Game.GetFormFromFile(0x0302A74D, "Chesko_Frostfall.esp") as Weapon			;_DE_Axe01_11
			_DE_Axe01_12 = Game.GetFormFromFile(0x0302A74E, "Chesko_Frostfall.esp") as Weapon			;_DE_Axe01_12
			_DE_Axe01_13 = Game.GetFormFromFile(0x0302A74F, "Chesko_Frostfall.esp") as Weapon			;_DE_Axe01_13
			_DE_Axe01_14 = Game.GetFormFromFile(0x0302A750, "Chesko_Frostfall.esp") as Weapon			;_DE_Axe01_14
			_DE_AxeBroken = Game.GetFormFromFile(0x0303F538, "Chesko_Frostfall.esp") as MiscObject			;_DE_AxeBroken
			_DE_DeadWood = Game.GetFormFromFile(0x0102564C, "Chesko_Frostfall.esp") as MiscObject			;_DE_DeadWood

			debug.notification("Dynamic Things - Support for Frostfall added")		
		endif
	endif

	if isPlaceableStatics && (wizCombatDummy03.HasForm(Game.GetFormFromFile(0x01008BD2, "AK- Placeable Statics.esp")))
		isPlaceableStatics= Game.GetFormFromFile(0x01008BCF, "AK- Placeable Statics.esp")
		if !isPlaceableStatics
			;Placeable statics was removed since the last save.
;			if (wizWoodPile.HasForm(Game.GetFormFromFile(0x01008BCF, "AK- Placeable Statics.esp")))
;				wizWoodPile.RemoveAddedForm(Game.GetFormFromFile(0x01008BCF, "AK- Placeable Statics.esp"))			;PSFirewoodPileLarge01
;				wizWoodPile.RemoveAddedForm(Game.GetFormFromFile(0x0100BD3A, "AK- Placeable Statics.esp"))			;PSFirewoodPileMedium01
;				wizWoodPile.RemoveAddedForm(Game.GetFormFromFile(0x0100455D, "AK- Placeable Statics.esp"))			;PDFirewoodPileSmall01
;			endif				
;			debug.notification("Dynamic Things - Support for Placeable Statics removed ")		
		else
			;Still installed - do nothing
		endif
	else
		isPlaceableStatics= Game.GetFormFromFile(0x01008BCF, "AK- Placeable Statics.esp")
		if isPlaceableStatics
			;Placeable Statics was just added.
			if !(wizWoodPile.HasForm(Game.GetFormFromFile(0x01008BCF, "AK- Placeable Statics.esp")))
				wizWoodPile.AddForm(Game.GetFormFromFile(0x01008BCF, "AK- Placeable Statics.esp"))			;PSFirewoodPileLarge01
				wizWoodPile.AddForm(Game.GetFormFromFile(0x0100BD3A, "AK- Placeable Statics.esp"))			;PSFirewoodPileMedium01
				wizWoodPile.AddForm(Game.GetFormFromFile(0x0100455D, "AK- Placeable Statics.esp"))			;PDFirewoodPileSmall01
			endif				
			if !(wizWoodPileLargeList.HasForm(Game.GetFormFromFile(0x01008BCF, "AK- Placeable Statics.esp")))
				wizWoodPileLargeList.AddForm(Game.GetFormFromFile(0x01008BCF, "AK- Placeable Statics.esp"))			;PSFirewoodPileLarge01
			endif				
			if !(wizWoodPileMediumList.HasForm(Game.GetFormFromFile(0x0100BD3A, "AK- Placeable Statics.esp")))
				wizWoodPileMediumList.AddForm(Game.GetFormFromFile(0x0100BD3A, "AK- Placeable Statics.esp"))			;PSFirewoodPileMedium01
			endif				
			if !(wizWoodPileSmallList.HasForm(Game.GetFormFromFile(0x0100455D, "AK- Placeable Statics.esp")))
				wizWoodPileSmallList.AddForm(Game.GetFormFromFile(0x0100455D, "AK- Placeable Statics.esp"))			;PSFirewoodPileSmall01
			endif		
			if !(wizBarrelList.HasForm(Game.GetFormFromFile(0x01004ADE, "AK- Placeable Statics.esp")))
				wizBarrelList.AddForm(Game.GetFormFromFile(0x01004ADE, "AK- Placeable Statics.esp"))			;PSBarrel02
			endif		
			if !(wizCrateSmall01List.HasForm(Game.GetFormFromFile(0x01003A8A, "AK- Placeable Statics.esp")))
				wizCrateSmall01List.AddForm(Game.GetFormFromFile(0x01003A8A, "AK- Placeable Statics.esp"))			
			endif		
			if !(wizCrateSmall01WeatheredList.HasForm(Game.GetFormFromFile(0x01003A8B, "AK- Placeable Statics.esp")))
				wizCrateSmall01WeatheredList.AddForm(Game.GetFormFromFile(0x01003A8B, "AK- Placeable Statics.esp"))			
			endif		
			if !(wizCrateSmall02List.HasForm(Game.GetFormFromFile(0x010080E4, "AK- Placeable Statics.esp")))
				wizCrateSmall02List.AddForm(Game.GetFormFromFile(0x010080E4, "AK- Placeable Statics.esp"))			
			endif		
			if !(wizCrateSmall02WeatheredList.HasForm(Game.GetFormFromFile(0x01005068, "AK- Placeable Statics.esp")))
				wizCrateSmall02WeatheredList.AddForm(Game.GetFormFromFile(0x01005068, "AK- Placeable Statics.esp"))			
			endif		
			if !(wizCrateSmall03List.HasForm(Game.GetFormFromFile(0x01007699, "AK- Placeable Statics.esp")))
				wizCrateSmall03List.AddForm(Game.GetFormFromFile(0x01007699, "AK- Placeable Statics.esp"))			
			endif		
			if !(wizCrateSmall03WeatheredList.HasForm(Game.GetFormFromFile(0x0100455C, "AK- Placeable Statics.esp")))
				wizCrateSmall03WeatheredList.AddForm(Game.GetFormFromFile(0x0100455C, "AK- Placeable Statics.esp"))			
			endif		
			if !(wizCrateSmall04List.HasForm(Game.GetFormFromFile(0x01003A7C, "AK- Placeable Statics.esp")))
				wizCrateSmall04List.AddForm(Game.GetFormFromFile(0x01003A7C, "AK- Placeable Statics.esp"))			
			endif		
			if !(wizCrateSmall04WeatheredList.HasForm(Game.GetFormFromFile(0x0100350D, "AK- Placeable Statics.esp")))
				wizCrateSmall04WeatheredList.AddForm(Game.GetFormFromFile(0x0100350D, "AK- Placeable Statics.esp"))			
			endif		
			if !(wizCrateSmallLong01List.HasForm(Game.GetFormFromFile(0x01003A7D, "AK- Placeable Statics.esp")))
				wizCrateSmallLong01List.AddForm(Game.GetFormFromFile(0x01003A7D, "AK- Placeable Statics.esp"))			
			endif		
			if !(wizCrateSmallLong01WeatheredList.HasForm(Game.GetFormFromFile(0x01003A7B, "AK- Placeable Statics.esp")))
				wizCrateSmallLong01WeatheredList.AddForm(Game.GetFormFromFile(0x01003A7B, "AK- Placeable Statics.esp"))			
			endif		
			if !(wizCrateSmallLong02List.HasForm(Game.GetFormFromFile(0x01008649, "AK- Placeable Statics.esp")))
				wizCrateSmallLong02List.AddForm(Game.GetFormFromFile(0x01008649, "AK- Placeable Statics.esp"))			
			endif		
			if !(wizCrateSmallLong02WeatheredList.HasForm(Game.GetFormFromFile(0x01003A91, "AK- Placeable Statics.esp")))
				wizCrateSmallLong02WeatheredList.AddForm(Game.GetFormFromFile(0x01003A91, "AK- Placeable Statics.esp"))			
			endif		
			if !(wizCrateSmallLong03WeatheredList.HasForm(Game.GetFormFromFile(0x01005066, "AK- Placeable Statics.esp")))
				wizCrateSmallLong03WeatheredList.AddForm(Game.GetFormFromFile(0x01005066, "AK- Placeable Statics.esp"))			
			endif		
			if !(wizCrateSmallLong04WeatheredList.HasForm(Game.GetFormFromFile(0x01003FF9, "AK- Placeable Statics.esp")))
				wizCrateSmallLong04WeatheredList.AddForm(Game.GetFormFromFile(0x01003FF9, "AK- Placeable Statics.esp"))			
			endif		
			if !(wizCrateSmallList.HasForm(Game.GetFormFromFile(0x01003A8A, "AK- Placeable Statics.esp")))
				wizCrateSmallList.AddForm(Game.GetFormFromFile(0x01003A8A, "AK- Placeable Statics.esp"))			
				wizCrateSmallList.AddForm(Game.GetFormFromFile(0x01003A8B, "AK- Placeable Statics.esp"))			
				wizCrateSmallList.AddForm(Game.GetFormFromFile(0x010080E4, "AK- Placeable Statics.esp"))			
				wizCrateSmallList.AddForm(Game.GetFormFromFile(0x01005068, "AK- Placeable Statics.esp"))			
				wizCrateSmallList.AddForm(Game.GetFormFromFile(0x01007699, "AK- Placeable Statics.esp"))			
				wizCrateSmallList.AddForm(Game.GetFormFromFile(0x0100455C, "AK- Placeable Statics.esp"))			
				wizCrateSmallList.AddForm(Game.GetFormFromFile(0x01003A7C, "AK- Placeable Statics.esp"))			
				wizCrateSmallList.AddForm(Game.GetFormFromFile(0x0100350D, "AK- Placeable Statics.esp"))			
			endif		
			if !(wizCrateLongList.HasForm(Game.GetFormFromFile(0x01003A7D, "AK- Placeable Statics.esp")))
				wizCrateLongList.AddForm(Game.GetFormFromFile(0x01003A7D, "AK- Placeable Statics.esp"))			
				wizCrateLongList.AddForm(Game.GetFormFromFile(0x01003A7B, "AK- Placeable Statics.esp"))			
				wizCrateLongList.AddForm(Game.GetFormFromFile(0x01008649, "AK- Placeable Statics.esp"))			
				wizCrateLongList.AddForm(Game.GetFormFromFile(0x01003A91, "AK- Placeable Statics.esp"))			
				wizCrateLongList.AddForm(Game.GetFormFromFile(0x01005066, "AK- Placeable Statics.esp"))			
				wizCrateLongList.AddForm(Game.GetFormFromFile(0x01003FF9, "AK- Placeable Statics.esp"))			
			endif		
			if !(wizCrateList.HasForm(Game.GetFormFromFile(0x01003A8A, "AK- Placeable Statics.esp")))
				wizCrateList.AddForm(Game.GetFormFromFile(0x01003A8A, "AK- Placeable Statics.esp"))			
				wizCrateList.AddForm(Game.GetFormFromFile(0x01003A8B, "AK- Placeable Statics.esp"))			
				wizCrateList.AddForm(Game.GetFormFromFile(0x010080E4, "AK- Placeable Statics.esp"))			
				wizCrateList.AddForm(Game.GetFormFromFile(0x01005068, "AK- Placeable Statics.esp"))			
				wizCrateList.AddForm(Game.GetFormFromFile(0x01007699, "AK- Placeable Statics.esp"))			
				wizCrateList.AddForm(Game.GetFormFromFile(0x0100455C, "AK- Placeable Statics.esp"))			
				wizCrateList.AddForm(Game.GetFormFromFile(0x01003A7C, "AK- Placeable Statics.esp"))			
				wizCrateList.AddForm(Game.GetFormFromFile(0x0100350D, "AK- Placeable Statics.esp"))			
				wizCrateList.AddForm(Game.GetFormFromFile(0x01003A7D, "AK- Placeable Statics.esp"))			
				wizCrateList.AddForm(Game.GetFormFromFile(0x01003A7B, "AK- Placeable Statics.esp"))			
				wizCrateList.AddForm(Game.GetFormFromFile(0x01008649, "AK- Placeable Statics.esp"))			
				wizCrateList.AddForm(Game.GetFormFromFile(0x01003A91, "AK- Placeable Statics.esp"))			
				wizCrateList.AddForm(Game.GetFormFromFile(0x01005066, "AK- Placeable Statics.esp"))			
				wizCrateList.AddForm(Game.GetFormFromFile(0x01003FF9, "AK- Placeable Statics.esp"))			
			endif		
			if !(wizBreweryCasks.HasForm(Game.GetFormFromFile(0x01008BD5, "AK- Placeable Statics.esp")))
				wizBreweryCasks.AddForm(Game.GetFormFromFile(0x01008BD5, "AK- Placeable Statics.esp"))			
			endif		
			if !(wizMeadBarrel01List.HasForm(Game.GetFormFromFile(0x01008BD5, "AK- Placeable Statics.esp")))
				wizMeadBarrel01List.AddForm(Game.GetFormFromFile(0x01008BD5, "AK- Placeable Statics.esp"))	;MeadBarrel01		
			endif		
			if !(wizArcheryTargetList.HasForm(Game.GetFormFromFile(0x0100E361, "AK- Placeable Statics.esp")))
				wizArcheryTargetList.AddForm(Game.GetFormFromFile(0x0100E361, "AK- Placeable Statics.esp"))	;Archery Target		
			endif		
			if !(wizMiscConversionList.HasForm(Game.GetFormFromFile(0x01008BD0, "AK- Placeable Statics.esp")))
				wizMiscConversionList.AddForm(Game.GetFormFromFile(0x01008BD5, "AK- Placeable Statics.esp"))	 ;MeadBarrel01
				wizMiscConversionList.AddForm(Game.GetFormFromFile(0x0100E361, "AK- Placeable Statics.esp"))	 ;Archery Target
				wizMiscConversionList.AddForm(Game.GetFormFromFile(0x01008BD0, "AK- Placeable Statics.esp"))	 ;PracticeDummy01
				wizMiscConversionList.AddForm(Game.GetFormFromFile(0x01008BD1, "AK- Placeable Statics.esp"))	 ;PracticeDummy02
				wizMiscConversionList.AddForm(Game.GetFormFromFile(0x01008BD2, "AK- Placeable Statics.esp"))	 ;PracticeDummy03
			endif		
			if !(wizCombatDummyList.HasForm(Game.GetFormFromFile(0x01008BD0, "AK- Placeable Statics.esp")))
				wizCombatDummyList.AddForm(Game.GetFormFromFile(0x01008BD0, "AK- Placeable Statics.esp"))	 ;PracticeDummy01
				wizCombatDummyList.AddForm(Game.GetFormFromFile(0x01008BD1, "AK- Placeable Statics.esp"))	 ;PracticeDummy02
				wizCombatDummyList.AddForm(Game.GetFormFromFile(0x01008BD2, "AK- Placeable Statics.esp"))	 ;PracticeDummy03
			endif		
			if !(wizCombatDummy01.HasForm(Game.GetFormFromFile(0x01008BD0, "AK- Placeable Statics.esp")))
				wizCombatDummy01.AddForm(Game.GetFormFromFile(0x01008BD0, "AK- Placeable Statics.esp"))	 ;PracticeDummy01
			endif		
			if !(wizCombatDummy02.HasForm(Game.GetFormFromFile(0x01008BD1, "AK- Placeable Statics.esp")))
				wizCombatDummy02.AddForm(Game.GetFormFromFile(0x01008BD1, "AK- Placeable Statics.esp"))	 ;PracticeDummy02
			endif		
			if !(wizCombatDummy03.HasForm(Game.GetFormFromFile(0x01008BD2, "AK- Placeable Statics.esp")))
				wizCombatDummy03.AddForm(Game.GetFormFromFile(0x01008BD2, "AK- Placeable Statics.esp"))	 ;PracticeDummy03
			endif		
			debug.notification("Dynamic Things - Support for Placeable Statics added ")		
		else
			;Still not installed so do nothing!
		endif
		
	endif
	;	debug.notification("Compatibility checks run!")
endFunction

function DegradeAxe()
	;Check for axe in right hand
	int whichHand
	weapon inHand = playerRef.GetEquippedWeapon(TRUE)
	if inHand && woodChoppingAxes.hasform(inHand)
		whichhand = 2	
	else
		inHand = playerRef.GetEquippedWeapon(FALSE)
		if inHand && woodChoppingAxes.hasform(inHand)
			whichhand = 1
		else
			;No woodcutter's axe in hand???
			inhand = None
		endIf	
	endIf
	
	if inHand
		if inHand == Axe01
			playerRef.RemoveItem(Axe01, abSilent = true)
			playerRef.AddItem(_DE_Axe01_14, abSilent = true)
			playerRef.EquipItemEX(_DE_Axe01_14, whichHand,false,true)
		elseif inHand == _DE_Axe01_14
			playerRef.RemoveItem(_DE_Axe01_14, abSilent = true)
			playerRef.AddItem(_DE_Axe01_13, abSilent = true)
			playerRef.EquipItemEX(_DE_Axe01_13, whichHand,false,true)
		elseif inHand == _DE_Axe01_13
			playerRef.RemoveItem(_DE_Axe01_13, abSilent = true)
			playerRef.AddItem(_DE_Axe01_12, abSilent = true)
			playerRef.EquipItemEX(_DE_Axe01_12, whichHand,false,true)
		elseif inHand == _DE_Axe01_12
			playerRef.RemoveItem(_DE_Axe01_12, abSilent = true)
			playerRef.AddItem(_DE_Axe01_11, abSilent = true)
			playerRef.EquipItemEX(_DE_Axe01_11, whichHand,false,true)
		elseif inHand == _DE_Axe01_11
			playerRef.RemoveItem(_DE_Axe01_11, abSilent = true)
			playerRef.AddItem(_DE_Axe01_10, abSilent = true)
			playerRef.EquipItemEX(_DE_Axe01_10, whichHand,false,true)
		elseif inHand == _DE_Axe01_10
			playerRef.RemoveItem(_DE_Axe01_10, abSilent = true)
			playerRef.AddItem(_DE_Axe01_9, abSilent = true)
			playerRef.EquipItemEX(_DE_Axe01_9, whichHand,false,true)
		elseif inHand == _DE_Axe01_9
			playerRef.RemoveItem(_DE_Axe01_9, abSilent = true)
			playerRef.AddItem(_DE_Axe01_8, abSilent = true)
			playerRef.EquipItemEX(_DE_Axe01_8, whichHand,false,true)
		elseif inHand == _DE_Axe01_8
			playerRef.RemoveItem(_DE_Axe01_8, abSilent = true)
			playerRef.AddItem(_DE_Axe01_7, abSilent = true)
			playerRef.EquipItemEX(_DE_Axe01_7, whichHand,false,true)
		elseif inHand == _DE_Axe01_7
			playerRef.RemoveItem(_DE_Axe01_7, abSilent = true)
			playerRef.AddItem(_DE_Axe01_6, abSilent = true)
			playerRef.EquipItemEX(_DE_Axe01_6, whichHand,false,true)
		elseif inHand == _DE_Axe01_6
			playerRef.RemoveItem(_DE_Axe01_6, abSilent = true)
			playerRef.AddItem(_DE_Axe01_5, abSilent = true)
			playerRef.EquipItemEX(_DE_Axe01_5, whichHand,false,true)
		elseif inHand == _DE_Axe01_5
			playerRef.RemoveItem(_DE_Axe01_5, abSilent = true)
			playerRef.AddItem(_DE_Axe01_4, abSilent = true)
			playerRef.EquipItemEX(_DE_Axe01_4, whichHand,false,true)
		elseif inHand == _DE_Axe01_4
			playerRef.RemoveItem(_DE_Axe01_4, abSilent = true)
			playerRef.AddItem(_DE_Axe01_3, abSilent = true)
			playerRef.EquipItemEX(_DE_Axe01_3, whichHand,false,true)
		elseif inHand == _DE_Axe01_3
			playerRef.RemoveItem(_DE_Axe01_3, abSilent = true)
			playerRef.AddItem(_DE_Axe01_2, abSilent = true)
			playerRef.EquipItemEX(_DE_Axe01_2, whichHand,false,true)
		elseif inHand == _DE_Axe01_2
			playerRef.RemoveItem(_DE_Axe01_2, abSilent = true)
			playerRef.AddItem(_DE_Axe01_1, abSilent = true)
			playerRef.EquipItemEX(_DE_Axe01_1, whichHand,false,true)
		elseif inHand == _DE_Axe01_1
			playerRef.RemoveItem(_DE_Axe01_1, abSilent = true)
			playerRef.AddItem(_DE_AxeBroken)
			debug.notification("The axe has broken")
		endIf

	endIf

EndFunction

;Event OnItemRemoved(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)
;	if !akDestContainer
;		Debug.Messagebox("I dropped " + aiItemCount + "x " + akBaseItem + " into the world")
;	elseif akDestContainer == Game.GetPlayer()
;		Debug.Messagebox("I gave the player " + aiItemCount + "x " + akBaseItem)
;	else
;		Debug.Messagebox("I gave " + aiItemCount + "x " + akBaseItem + " to another container")
;	endIf
;endEvent

;Event OnLocationChange(Location akOldLoc, Location akNewLoc)
;	myLocation = akNewLoc
;	debug.messagebox(mylocation)
;endEvent