Scriptname wizFireWoodPlayerAliasScript extends ReferenceAlias  

Actor Property playerREF Auto
Quest Property wizFireWoodQuest Auto
Quest Property wizPickaxeQuest Auto
Keyword Property WeapTypeBattleAxe Auto
;Keyword Property WeapTypeWarAxe Auto
GlobalVariable Property wizAxeEquipped Auto
GlobalVariable Property wizPickaxeEquipped Auto
GlobalVariable Property wizSafeContainer Auto
GlobalVariable Property wizContainerMenuOpen Auto
GlobalVariable Property wizDynamicThingsEnabled Auto
GlobalVariable Property wizOptionDynamicSafeContainersEnabled Auto
FormList Property woodChoppingAxes Auto
FormList Property wizPickAxes Auto
FormList Property wizSafeContainerNotList Auto
FormList Property wizDTContainerList Auto
Activator Property wizSafeContainerMarker Auto
Message Property wizConvertSafeContainer Auto

Event OnInit()
;	debug.notification("Player Alias Initializaed")
	RegisterForMenu("ContainerMenu")
endEvent

Event OnPlayerLoadGame()
	RegisterForMenu("ContainerMenu")
endEvent

Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
	if akBaseObject as Weapon
		;Can use GetWeaponType = 3 for all War Axes but WeaponType 6 means BattleAxes and Warhammers so check for keyword for warhammers :-(
;		if (akBaseObject as Weapon).GetWeaponType() == 3 || akBaseObject.HasKeyword(WeapTypeBattleAxe)
		if woodChoppingAxes.hasform(akBaseObject)
;			debug.Notification("Looking for wood")
			wizAxeEquipped.setValue(1)
			wizFirewoodQuest.Stop()
			wizFirewoodQuest.Start()
		ElseIf wizPickAxes.hasform(akBaseObject)
;			debug.Notification("Looking for rocks")
			wizPickaxeEquipped.setValue(1)
			wizPickaxeQuest.Stop()
			wizPickaxeQuest.Start()
		endIf

	endif
endEvent


Event OnObjectUnequipped(Form akBaseObject, ObjectReference akReference)
	if akBaseObject as Weapon
		;Can use GetWeaponType = 3 for all War Axes but WeaponType 6 means BattleAxes and Wrhammers so check for keyword for warhammers :-(
;		if (akBaseObject as Weapon).GetWeaponType() == 3 || akBaseObject.HasKeyword(WeapTypeBattleAxe)
		if woodChoppingAxes.hasform(akBaseObject)
			;We just disabled an axe, but we could be dual wielding so check both hands
			weapon inHand = playerRef.GetEquippedWeapon(TRUE)
;			if inHand && (inHand.GetWeaponType() == 3 || inHand.HasKeyword(WeapTypeBattleAxe))
			if inHand && woodChoppingAxes.hasform(inHand)
				wizAxeEquipped.setValue(1)
			else
				inHand = playerRef.GetEquippedWeapon(FALSE)
;				if inHand && (inHand.GetWeaponType() == 3 || inHand.HasKeyword(WeapTypeBattleAxe))
				if inHand && woodChoppingAxes.hasform(inHand)
					wizAxeEquipped.setValue(1)
				else
					wizAxeEquipped.setValue(0)
					wizFirewoodQuest.Stop()
;					debug.Notification("No longer looking for wood")
				endIf	

			endIf
		elseIf wizPickAxes.hasform(akBaseObject)
			;We just disabled a pickaxe, but we could be dual wielding so check both hands
			weapon inHand = playerRef.GetEquippedWeapon(TRUE)
			if inHand && wizPickAxes.hasform(inHand)
				wizPickaxeEquipped.setValue(1)
			else
				inHand = playerRef.GetEquippedWeapon(FALSE)
				if inHand && wizPickAxes.hasform(inHand)
					wizPickaxeEquipped.setValue(1)
				else
					wizPickaxeEquipped.setValue(0)
					wizPickaxeQuest.Stop()
;					debug.Notification("No longer looking for wood")
				endIf	

			endIf
		endIf

	endif
endEvent

Event OnItemRemoved(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)
;	debug.messagebox(akDestContainer + " " + akDestContainer.getbaseobject().getType())

	if wizContainerMenuOpen.getValueInt() == 1 && wizOptionDynamicSafeContainersEnabled.getvalueint() == 1 && wizDynamicThingsEnabled.GetValueint() == 1
;	if wizOptionDynamicSafeContainersEnabled.getvalueint() == 1 && wizDynamicThingsEnabled.GetValueint() == 1
		;Was the item removed placed into a container?
		If akDestContainer && akDestContainer.getbaseobject().getType() == 28 && !wizSafeContainerNotList.HasForm(akDestContainer);Container
			int ContID = akDestContainer.getFormID() 
			if ContID != wizSafeContainer.getValueInt()
				;New container check
				wizSafeContainer.setValue(ContID)
			
				;FF000000 = 4278190080  If a form begins with FF it was placed via script and will never respawn
				if akDestContainer.getFormID() <  4278190080
					;Do we want to replace?
					int Replace = wizConvertSafeContainer.show()
					if Replace == 0;Yes
						akDestContainer.placeAtMe(wizSafeContainerMarker)
;						debug.messagebox("Do not transfer any additional items at this time. Please exit the container menu and use the new container that will appear.")

;						Game.DisablePlayerControls()
;						Game.EnablePlayerControls()

;						debug.notification("Marker Placed")
					elseIf Replace == 1 ;No
						;Do nothing
					elseIf Replace == 2 ;Never ask again
						;Add to never ask list
						if !wizSafeContainerNotList.HasForm(akDestContainer)
							wizSafeContainerNotList.AddForm(akDestContainer)
						endIf
					endIf
				else
					;If container isn't a DT container
					if !wizDTContainerList.HasForm(akDestContainer.GetBaseObject())
						debug.notification("Dynamic Things: This container is already safe for storage")
					endIf
				endIf

			else
				;We've already checked this container recently
			endIf
		endIf
	endIf
endEvent

Event OnMenuOpen(String MenuName)

;debug.notification(MenuName +" opened")

	If MenuName == "ContainerMenu"
		wizContainerMenuOpen.setvalue(1)
	endIf
endEvent

Event OnMenuClose(String MenuName)
	If MenuName == "ContainerMenu"
		wizContainerMenuOpen.setvalue(0)
	endIf
endEvent
