Scriptname wizMeadBarrel01StaticScript extends ObjectReference  


Actor Property PlayerREF Auto
MiscObject Property Gold001 Auto
GlobalVariable Property wizDynamicThingsEnabled Auto 
GlobalVariable Property wizOptionMiscsEnabled Auto 
GlobalVariable Property wizOptionDTResetTime Auto
Message Property wizFillEmptyBottle Auto
FormList Property EmptyBottles Auto
Potion Property FoodMead Auto
Potion Property FoodBlackBriarMead Auto
Potion Property FoodBlackBriarMeadPrivateReserve Auto
Potion Property FoodHonningbrewMead Auto
Potion Property Skooma Auto

Perk Property Haggling00 Auto
Perk Property Haggling20 Auto
Perk Property Haggling40 Auto
Perk Property Haggling60 Auto
Perk Property Haggling80 Auto
;Perk Property Allure Auto

MagicEffect Property AlchFortifyBarter Auto

Activator Property wizMeadBarrel01Static Auto
Activator Property wizBlackBriarMeadBarrel Auto
Activator Property wizBlackBriarMeadPrivateReserveBarrel Auto
Activator Property wizHonningbrewMeadBarrel Auto
Activator Property wizSkoomaBarrel Auto
Activator Property wizWaterBarrel Auto
Activator Property wizMeadBarrelBloodDrip01 Auto
Activator Property wizMeadBarrelBloodDrip02 Auto

Location Property EastmarchHoldLocation Auto
Location Property FalkreathHoldLocation Auto
Location Property HaafingarHoldLocation Auto
Location Property HjaalmarchHoldLocation Auto
Location Property PaleHoldLocation Auto
Location Property ReachHoldLocation Auto
Location Property RiftHoldLocation Auto
Location Property WhiterunHoldLocation Auto
Location Property WinterholdHoldLocation Auto

Faction Property CrimeFactionEastmarch Auto
Faction Property CrimeFactionFalkreath Auto
Faction Property CrimeFactionHaafingar Auto
Faction Property CrimeFactionHjaalmarch Auto
Faction Property CrimeFactionPale Auto
Faction Property CrimeFactionReach Auto
Faction Property CrimeFactionRift Auto
Faction Property CrimeFactionWhiterun Auto
Faction Property CrimeFactionWinterhold Auto
Faction Property JobMerchantFaction Auto

Float Respawn

Event OnActivate(ObjectReference akActionRef)
;	debug.messagebox("Begin Activate")
	Actor NPC = akActionRef as Actor
	cell kCell= self.GetParentCell()
	bool StealCheck
	bool FriendlyFaction

	;Does the player belong to the faction that owns this cell?
	faction CellFaction = kCell.getFactionOwner()
	if CellFaction && playerref.GetFactionRank(CellFaction) >= 0
		FriendlyFaction= True
	endIf

	;Are we in an Inn or Store - do not pay if invested in store!
	if  self.getcurrentlocation() && (self.getcurrentlocation().haskeyword(Keyword.getkeyword("LocTypeInn")) || self.getcurrentlocation().haskeyword(Keyword.getkeyword("LocTypeStore"))) && FriendlyFaction == False
		;Inn or store - Are we trying to steal the drink or pay for it?
		if playerREF.isSneaking()
			;Trying to steal
			StealCheck = True
		else
			;Take payment
			;Base Gold	
			int Gold 
			if self.getbaseobject() == wizMeadBarrel01Static 
				Gold = FoodMead.GetGoldValue()
			Elseif self.getbaseobject() == wizBlackBriarMeadBarrel
				Gold = FoodBlackBriarMead.GetGoldValue()
			Elseif self.getbaseobject() == wizBlackBriarMeadPrivateReserveBarrel
				Gold = FoodBlackBriarMeadPrivateReserve.GetGoldValue()
			Elseif self.getbaseobject() == wizHonningbrewMeadBarrel
				Gold = FoodHonningbrewMead.GetGoldValue()
			Elseif self.getbaseobject() == wizSkoomaBarrel
				Gold = Skooma.GetGoldValue()
			Elseif self.getbaseobject() == wizWaterBarrel ;Only pssible with RND
				Gold = (Game.GetFormFromFile(0x010053E7, "RealisticNeedsandDiseases.esp") AS Potion).GetGoldValue()
			Elseif self.getbaseobject() == wizMeadBarrelBloodDrip01;Only pssible with Dawnguard
				Gold = (Game.GetFormFromFile(0x01018EF3, "Dawnguard.esm") AS Potion).GetGoldValue()
			Elseif self.getbaseobject() == wizMeadBarrelBloodDrip02;Only pssible with Dawnguard
				Gold = (Game.GetFormFromFile(0x01018EF3, "Dawnguard.esm") AS Potion).GetGoldValue()
			endIf

			;Get true gold price - accounting for speechcraft and perks
			Gold = Gold_Price(Gold, NPC)

			if NPC.GetGoldAmount() < Gold
				;Not enough gold!
				debug.notification("I do not have enough gold for that")
				Return ;Does this exit the event?
			else
				NPC .RemoveItem(Gold001, Gold)
			endIf
			
			;Can we give the gold to the merchant in the area?
			Int iIndex = kCell.GetNumRefs(43) ; kNPC = 43

			;Are we a merchant?
			While iIndex
				iIndex -= 1
				actor Merchant = kCell.GetNthRef(iIndex, 43) as Actor
				if Merchant != playerRef
					if Merchant.IsInFaction(JobMerchantFaction)
						Merchant.additem(Gold001, Gold)
						iIndex = 0 ;Should exit while
					endIf
				endIf
			EndWhile		
		endIf

	else
		;Does the player belong to the faction that owns this cell?
		if FriendlyFaction == False
			;Always perform steal check if not paying for drink and doesn't belong to faction
			StealCheck = True
		endIf
	endIf

;	debug.messagebox("Faction and Inn Check")


	;Do we have empty bottles?
	bool FillBottle
	int Empties = NPC.GetItemCount(EmptyBottles)
	if Empties > 0
		;Take drink or fill bottle?
		int iButton = wizFillEmptyBottle.show()
		if iButton == 0
			;Fill Bottle
			FillBottle= true
		else
			;Take Drink
			FillBottle = false
		endIf

	else
		;Simply drinking - no bottles
		FillBottle = false
	endIf

;	debug.messagebox("Bottle Check")

	if FillBottle == true
		;Fill Bottle
		NPC.removeItem(EmptyBottles, 1, True)
		if self.getbaseobject() == wizMeadBarrel01Static
			akActionRef.additem(FoodMead,1,False)
		Elseif self.getbaseobject() == wizBlackBriarMeadBarrel
			akActionRef.additem(FoodBlackBriarMead,1,False)
		Elseif self.getbaseobject() == wizBlackBriarMeadPrivateReserveBarrel
			akActionRef.additem(FoodBlackBriarMeadPrivateReserve,1,False)
		Elseif self.getbaseobject() == wizHonningbrewMeadBarrel
			akActionRef.additem(FoodHonningbrewMead,1,False)
		Elseif self.getbaseobject() == wizSkoomaBarrel
			akActionRef.additem(Skooma,1,False)
		Elseif self.getbaseobject() == wizWaterBarrel ;Only pssible with RND
			akActionRef.additem(Game.GetFormFromFile(0x010053E7, "RealisticNeedsandDiseases.esp") AS Potion,1,False)
		Elseif self.getbaseobject() == wizMeadBarrelBloodDrip01 ;Only pssible with Dawnguard
			akActionRef.additem(Game.GetFormFromFile(0x01018EF3, "Dawnguard.esm") AS Potion,1,False)
		Elseif self.getbaseobject() == wizMeadBarrelBloodDrip02 ;Only pssible with Dawnguard
			akActionRef.additem(Game.GetFormFromFile(0x01018EF3, "Dawnguard.esm") AS Potion,1,False)
	endIf
	else
;		debug.messagebox(self.getbaseobject() + " - " + wizMeadBarrelBloodDrip01 + " " + wizMeadBarrelBloodDrip02)

		;Drink Mead
		if self.getbaseobject() == wizMeadBarrel01Static
			akActionRef.additem(FoodMead,1,True)
;			Potion Drink = FoodMead
;			MagicEffect Effect = Drink.GetNthEffectMagicEffect(0)
;			NPC.EquipItem(Effect)
;			debug.messagebox(Effect)
			NPC .EquipItem(FoodMead, False, True)
		Elseif self.getbaseobject() == wizBlackBriarMeadBarrel
			akActionRef.additem(FoodBlackBriarMead,1,True)
			NPC .EquipItem(FoodBlackBriarMead, False, True)
		Elseif self.getbaseobject() == wizBlackBriarMeadPrivateReserveBarrel
			akActionRef.additem(FoodBlackBriarMeadPrivateReserve,1,False)
			NPC .EquipItem(FoodBlackBriarMeadPrivateReserve, False, True)
		Elseif self.getbaseobject() == wizHonningbrewMeadBarrel
			akActionRef.additem(FoodHonningbrewMead,1,False)
			NPC .EquipItem(FoodHonningbrewMead, False, True)
		Elseif self.getbaseobject() == wizSkoomaBarrel
			akActionRef.additem(Skooma,1,False)
			NPC .EquipItem(Skooma, False, True)
		Elseif self.getbaseobject() == wizWaterBarrel ;Only pssible with RND
			potion Water = Game.GetFormFromFile(0x0100FBA3, "RealisticNeedsandDiseases.esp") AS Potion
			akActionRef.additem(Water,1, False)
			NPC .EquipItem(Water, False, True)
		Elseif self.getbaseobject() == wizMeadBarrelBloodDrip01 ;Only pssible with Dawnguard
			potion Blood = Game.GetFormFromFile(0x01018EF3, "Dawnguard.esm") AS Potion
			akActionRef.additem(Blood ,1, False)
			NPC.EquipItem(Blood , False, True)
		Elseif self.getbaseobject() == wizMeadBarrelBloodDrip02 ;Only pssible with Dawnguard
			potion Blood = Game.GetFormFromFile(0x01018EF3, "Dawnguard.esm") AS Potion
			akActionRef.additem(Blood ,1, False)
			NPC.EquipItem(Blood , False, True)
		endIf
	
		;Wait to drink to look for empties again
		utility.wait(0.5)
		int newEmpties = NPC.GetItemCount(EmptyBottles)
		if newEmpties - Empties > 0 
			;Remove the appropriate number of bottles
			npc.removeitem(EmptyBottles, newEmpties - Empties , true)
			;debug.messagebox("Empties removed")
		endIf

	endIf

	
	if StealCheck == True
		;Are we caught?
		Int iIndex = kCell.GetNumRefs(43) ; kNPC = 43

		;Are we detected by NPC's
		While iIndex
			iIndex -= 1
			actor Detected = kCell.GetNthRef(iIndex, 43) as Actor
			if Detected != playerRef && Detected.GetRelationshipRank(playerRef) < 1 && !Detected.IsPlayerTeammate() ;Also check for "friendly to player"
				if PlayerREF.IsDetectedBy(Detected)
					;If detected attack me!
					Detected.SendAssaultAlarm()
				endIf
			endIf
		EndWhile		

		;Add Crime?
		;Report_Crime(self.getcurrentlocation(), gold/2)

	endIf


EndEvent

Event OnCellDetach()
	Respawn = Utility.GetCurrentGameTime()
endEvent

Event OnCellAttach()

	if utility.getCurrentGameTime() >= (Respawn + (wizOptionDTResetTime.getvalue() as float))
		Self.disable()
		Self.delete()
		Return
	endIf

endEvent




int Function Gold_Price (int Gold, Actor NPC) 
	;All costing taken from here - http://www.uesp.net/wiki/Skyrim_talk:Speech
	;This doesn't tkae into account potions or enchantments

	;Check for perks
	Float PerkAdj 
	if NPC.HasPerk(Haggling80)
		PerkAdj = 0.77
	Elseif NPC.HasPerk(Haggling60)
		PerkAdj = 0.80
	Elseif NPC.HasPerk(Haggling40)
		PerkAdj = 0.83
	Elseif NPC.HasPerk(Haggling20)
		PerkAdj = 0.87
	Elseif NPC.HasPerk(Haggling00)
		PerkAdj = 0.91
	Else
		PerkAdj = 1.00
	EndIf
	;Allure has no effect because the cask isn't male or female

	;Take into account speechcraft
	int Speech = NPC.getAV("Speechcraft") as int	
	float priceFactor = 3.3 - (1.3 * Speech/100)

	Gold = ((Gold * PerkAdj * PriceFactor) + 0.5)  as Int
	Return Gold
endFunction

;Function Report_Crime(location loc, int gold)
;	if PlayerREF.IsInLocation(EastmarchHoldLocation)
;		CrimeFactionEastmarch.ModCrimeGold(Gold)
;		debug.notification(gold + " bounty added to Eastmarch" )
;	ElseIf PlayerREF.IsInLocation(FalkreathHoldLocation)
;		CrimeFactionFalkreath.ModCrimeGold(Gold)
;		debug.notification(gold + " bounty added to Falkreath" )
;	ElseIf PlayerREF.IsInLocation(HaafingarHoldLocation)
;		CrimeFactionHaafingar.ModCrimeGold(Gold)
;		debug.notification(gold + " bounty added to Haafingar" )
;	ElseIf PlayerREF.IsInLocation(HjaalmarchHoldLocation)
;		CrimeFactionHjaalmarch.ModCrimeGold(Gold)
;		debug.notification(gold + " bounty added to Hjaalmarch") 
;	ElseIf PlayerREF.IsInLocation(PaleHoldLocation)
;		CrimeFactionPale.ModCrimeGold(Gold)
;		debug.notification(gold + " bounty added to Pale" )
;	ElseIf PlayerREF.IsInLocation(ReachHoldLocation)
;		CrimeFactionReach.ModCrimeGold(Gold)
;		debug.notification(gold + " bounty added to Reach") 
;	ElseIf PlayerREF.IsInLocation(RiftHoldLocation)
;		CrimeFactionRift.ModCrimeGold(Gold)
;		debug.notification(gold + " bounty added to Rift" )
;	ElseIf PlayerREF.IsInLocation(WhiterunHoldLocation)
;		CrimeFactionWhiterun.ModCrimeGold(Gold)
;		debug.notification(gold + " bounty added to Whiterun") 
;	ElseIf PlayerREF.IsInLocation(WinterholdHoldLocation)
;		CrimeFactionWinterhold.ModCrimeGold(Gold)
;		debug.notification(gold + " bounty added to Winterhold" )
;	Else
;		;Need to check for Dragonborn!
;	endIf
;
;endFunction

