Scriptname wizTreeMarkerScript extends ObjectReference  

;This is only used to disable the tree and regrow it later

FormList Property wizTreeList Auto
GlobalVariable Property wizOptionDTResetTime Auto
GlobalVariable Property wizOptionTreesRegrow Auto

Float ResetTime
Float originalScale
objectReference ClosestTree
bool ParentIssues

event onInit()

	if ClosestTree == None ;First Once
		ClosestTree = Game.FindClosestReferenceOfAnyTypeInListFromRef(wizTreeList, self, 15)
	
		if ClosestTree
			originalScale= ClosestTree.getScale()
			ClosestTree.disable()
						
			if !ClosestTree.isDisabled()
				;This catches parent problems and add it to an ignore list to prevent
				debug.trace ("********** wizDYNAMIC THINGS - The Enable State Parent error above has been accounted for and will not occur again for this object **********")
				ParentIssues = TRUE
				ClosestTree.setscale(0.05)
			endIf
		else
			;No bush?
			self.disable()
			self.delete()
			return
		endIf

		ResetTime = Utility.GetCurrentGameTime()
	endIf

endEvent

Event OnCellDetach()

	;Restore bush
	if ParentIssues != TRUE
		ClosestTree.enable()
	else
		ClosestTree.setscale(originalScale)
	endIf

	ResetTime = Utility.GetCurrentGameTime() 

;	debug.messagebox("Current:" + Utility.GetCurrentGameTime() + " Reset:" + ResetTime)

endEvent


Event OnCellAttach()
	;Are we past the reset time?
	
;	debug.messagebox(Utility.GetCurrentGameTime() + ">" + ResetTime + " " + ClosestTree + " " + ParentIssues)

	if utility.getCurrentGameTime() >= (ResetTime+ (wizOptionDTResetTime.getvalue() as float)) && wizOptionTreesRegrow.GetValueInt() == 1
		;Leave visisble and delete this marker
		self.disable()
		self.delete()
	else
		;Still not reset
		if ClosestTree
			if ParentIssues != TRUE
				ClosestTree.disable()
			else
				ClosestTree.setScale(0.05)
			endIf
		else
			;No bush?
			self.disable()
			self.delete()
		endIf

	endIf
endEvent