Scriptname wizWoodPileMarkerScript extends ObjectReference  

wizDTCompatibility Property Compatibility Auto
Container Property wizWoodPileSmallStatic Auto
Container Property wizWoodPileMediumStatic Auto
Container Property wizWoodPileLargeStatic Auto
Container Property wizWoodPileHugeStatic Auto
FormList Property wizParentIssues Auto
FormList Property wizWoodPile Auto
FormList Property wizWoodPileSmallList Auto
FormList Property wizWoodPileMediumList Auto
FormList Property wizWoodPileLargeList Auto
FormList Property wizWoodPileHugeList Auto
FormList Property wizWoodPileContainers Auto
FormList Property wizHabitation Auto
MiscObject property myFuel auto
GlobalVariable Property wizDynamicThingsEnabled Auto 
GlobalVariable Property wizOptionWoodPilesEnabled Auto 
GlobalVariable Property wizOptionDTResetTime Auto 
Actor Property ArngeirREF Auto
Actor Property playerREF Auto

ObjectReference ClosestWoodPile
ObjectReference WoodPileContainer
Bool ParentIssues
Float Respawn

;These didn't work!
;Keyword property LocTypeCity auto
;Keyword property LocTypeTown auto


Event OnInit()
	;debug.messagebox(WoodPileContainer)
	if WoodPileContainer == None ;Only fire once
		PlacePile()
		Respawn = utility.getCurrentGameTime()
	endIf

endEvent


Event OnCellDetach()
	;Re-enable static wood pile - this is mainly for unistallation puposes
	if ParentIssues != TRUE
		ClosestWoodPile.enable()
	endIf

	if WoodPileContainer
		;Disable wood pile container
		WoodPileContainer.disable()
	else
		self.disable()
		self.delete()
	endIf

	Respawn = utility.getCurrentGameTime()

endEvent

Event OnCellAttach()
;	debug.notification("Marker Attached")

	if wizOptionWoodPilesEnabled.getvalueint() == 1 && wizDynamicThingsEnabled.getvalueint() == 1
		;Find the curent closest wood pile - may be dufferent if Placeable Statics has been removed!
		ClosestWoodPile = Game.FindClosestReferenceOfAnyTypeInListFromRef(wizWoodPile, self, 15)
		if ClosestWoodPile == None  || ClosestWoodPile.isDeleted() || ClosestWoodPile.isDisabled()
			;Wood pile moved - caused by another mod moving a vanilla object
			WoodPileContainer.disable()
			WoodPileContainer.delete()
			self.disable()
			self.delete()
		else
			;Might this container be respawning?
			if utility.getCurrentGameTime() >= (Respawn + (wizOptionDTResetTime.getvalue() as float))
				;We are going to loop for 3 seconds to see if WoodPileContainer gets deleted!
				int iLoop = 6
				While iLoop
					;Is the container deleted?
					if WoodPileContainer.isDeleted()
;						debug.messagebox("WoodPile Container Deleted!")
						PlacePile()
						iLoop = 0
					else
						Utility.wait(0.5)
						iLoop = (iLoop - 1)
					endIf
				endWhile
				
			endIf
			if ParentIssues != TRUE && !wizParentIssues.HasForm(ClosestWoodPile)
				ClosestWoodPile.disable()

				if !ClosestWoodPile.IsDisabled()
					;This catches parent problems and add it to an ignore list to prevent
					debug.trace ("********** wizDYNAMIC THINGS - The Enable State Parent error above has been accounted for and will not occur again for this object **********")
					ParentIssues = TRUE
					;Add to parent issues for logging!
					if !(wizParentIssues.HasForm(ClosestWoodPile)) 
						wizParentIssues.AddForm(ClosestWoodPile)
					endIf
;					debug.messagebox(ClosestWoodPile)
				endIf

			endIf

			if WoodPileContainer
				if WoodPileContainer.GetNumItems() != 0 
					WoodPileContainer.enable()
				endIf
		
				if  self.getcurrentlocation() && self.getcurrentlocation().haskeyword(Keyword.getkeyword("LocTypeHabitation"))
					WoodPileContainer.SetActorOwner(ArngeirREF.GetActorBase())
				endIf

			else
				self.disable()
				self.delete()
			endIf
			
		endIf

	EndIf
endEvent

function PlacePile()
		;Which wood pile are we replacing?
		ClosestWoodPile = Game.FindClosestReferenceOfAnyTypeInListFromRef(wizWoodPile, self, 15)
		
		if !ClosestWoodPile 
			;How do we exist then?
			if WoodPileContainer
				WoodPileContainer.disable()
				WoodPileContainer.delete()
			endIf
			self.disable()
			self.delete()
			return
		endIf

		if wizWoodPileSmallList.HasForm(ClosestWoodPile.getBaseObject())
			WoodPileContainer = self.placeatme(wizWoodPileSmallStatic)
			if Compatibility.isFrostfall
				WoodPileContainer.additem(Game.GetFormFromFile(0x0102564C, "Chesko_Frostfall.esp") as MiscObject, utility.RandomInt(1,2),TRUE)
			endIf
		elseIf wizWoodPileMediumList.HasForm(ClosestWoodPile.getBaseObject())
			WoodPileContainer = self.placeatme(wizWoodPileMediumStatic)
			if Compatibility.isFrostfall
				WoodPileContainer.additem(Game.GetFormFromFile(0x0102564C, "Chesko_Frostfall.esp") as MiscObject, utility.RandomInt(2,4),TRUE)
			endIf
		elseIf wizWoodPileLargeList.HasForm(ClosestWoodPile.getBaseObject())
			WoodPileContainer = self.placeatme(wizWoodPileLargeStatic)
			if Compatibility.isFrostfall
				WoodPileContainer.additem(Game.GetFormFromFile(0x0102564C, "Chesko_Frostfall.esp") as MiscObject, utility.RandomInt(3,5),TRUE)
			endIf
		elseIf wizWoodPileHugeList.HasForm(ClosestWoodPile.getBaseObject())
			WoodPileContainer = self.placeatme(wizWoodPileHugeStatic)
			if Compatibility.isFrostfall
				WoodPileContainer.additem(Game.GetFormFromFile(0x0102564C, "Chesko_Frostfall.esp") as MiscObject, utility.RandomInt(4,6),TRUE)
			endIf
		EndIf

		WoodPileContainer.SetAngle(self.GetAngleX(), self.GetAngleY(), self.GetAngleZ())
		;Set the Scale!
		WoodPileContainer.SetScale(ClosestWoodPile.getscale())

		;Make woodpile container owned???
		if  self.getcurrentlocation() && self.getcurrentlocation().haskeyword(Keyword.getkeyword("LocTypeHabitation"))
			WoodPileContainer.SetActorOwner(ArngeirREF.GetActorBase())
		endIf

		utility.wait(1) ;This should help reduce flicker

		if ParentIssues != TRUE && !wizParentIssues.HasForm(ClosestWoodPile)
			ClosestWoodPile.disable()
			if !ClosestWoodPile.IsDisabled()
				;This catches parent problems and add it to an ignore list to prevent
				debug.trace ("********** wizDYNAMIC THINGS - The Enable State Parent error above has been accounted for and will not occur again for this object **********")
				ParentIssues = TRUE
				;Add to parent issues for logging!
				if !(wizParentIssues.HasForm(ClosestWoodPile)) 
					wizParentIssues.AddForm(ClosestWoodPile)
				endIf
;				debug.messagebox(ClosestWoodPile)
			endIf
		else
			;Known parent issues!
			ParentIssues = TRUE
		endIf


endFunction

